//Eba li deni?
//N+C
#include<bits/stdc++.h>
using namespace std;
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define endl "\n"

const int MAX_N = 5e3 + 10;
ll n, k;
ll pre[MAX_N][MAX_N];

ll query(int i, int j, int m) {
	ll ret = pre[i + m][j + m];
	if(i > 0) {
		ret -= pre[i - 1][j + m];
	}
	if(j > 0) {
		ret -= pre[i + m][j - 1];
	}
	if(i > 0 && j > 0) {
		ret += pre[i - 1][j - 1];
	}
	return ret;
}

bool eval(int m) {
	//cout << endl << m << endl;
	for(int i = 0; i + m <= n; i ++) {
		for(int j = 0; j + m <= n; j ++) {
			//cout << query(i, j, m - 1) << " ";
			if(query(i, j, m - 1) < k) {
				//cout << i << " " << j << " " << m << " " << query(i, j, m) << endl;
				return false;
			}
		}
		//cout << endl;
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL);
	cin >> n >> k;
	for(int i = 0; i < n; i ++) {
		for(int j = 0; j < n; j ++) {
			cin >> pre[i][j];
		}
	}
	for(int i = 0; i < n; i ++) {
		for(int j = 0; j < n; j ++) {
			if(i > 0) {
				pre[i][j] += pre[i - 1][j];
			}
			if(j > 0) {
				pre[i][j] += pre[i][j - 1];
			}
			if(i > 0 && j > 0) {
				pre[i][j] -= pre[i - 1][j - 1];
			}
			//cout << pre[i][j] << " ";
		}
		//cout << endl;
	}
	int l = 0, r = n + 1;
	while(l != r - 1) {
		int m = (l + r) / 2;
		if(eval(m)) {
			r = m;
		} else {
			l = m;
		}
		//cout << l << " " << r << " " << eval(m) << endl;
	}
	if(r == n + 1) {
		cout << -1;
	} else {
		cout << r;
	}
	return 0;
}


