#include<iostream>
using namespace std;

const int MAX_N = 5002;

int n, k, a;

int prefixrow[MAX_N][MAX_N];
int prefixcol[MAX_N][MAX_N];

int l, r;
int m, curr, copycurr;

bool ok;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k;

    for(int y = 1; y <= n; y++){
        for(int x = 1; x <= n; x++){
            cin >> a;
            prefixrow[y][x] = prefixrow[y][x-1] + a;
            prefixcol[y][x] = prefixcol[y-1][x] + a;
        }
    }


    l = 1;
    r = n;
    while(l != r){
        m = (l+r)/2;
        curr = 0;
        ok = true;

        for(int i = 1; i <= m; i++){
            curr+= prefixrow[i][m];
        }

        //cout << m << endl;

        for(int x = 1; x+m <= n+1 && ok; x++){
            copycurr = curr;
            for(int y = 1; y+m <= n+1 && ok; y++){
                if(copycurr < k){ok = false;}
                //cout << copycurr << endl;
                copycurr = copycurr + (prefixrow[y+m][x+m-1] - prefixrow[y+m][x-1]) - (prefixrow[y][x+m-1] - prefixrow[y][x-1]);
            }
            curr = curr - prefixcol[m][x] + prefixcol[m][x+m];
        }

        if(ok){
            r = m;
        }else{
            l = m+1;
        }

        cout << "Separator\n";

    }

    cout << l << endl;


return 0;
}
/*
5 10
1 2 3 4 5
10 0 7 0 4
0 0 2 1 3
5 0 3 0 2
0 5 0 8 0

        if(curr < k){
            l = m+1;
            continue;
        }else{
            r = m;
            continue;
        }
*/
