#include<iostream>
using namespace std;

const int MAX_N = 5070;

long long n, k, a;

long long prefixrow[MAX_N][MAX_N];
long long prefixcol[MAX_N][MAX_N];

long long l, r;
long long m, curr, copycurr;
long long sumall;

bool ok;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k;

    for(long long y = 1; y <= n; y++){
        for(long long x = 1; x <= n; x++){
            cin >> a;
            sumall += a;
            prefixrow[y][x] = prefixrow[y][x-1] + a;
            prefixcol[y][x] = prefixcol[y-1][x] + a;
        }
    }

    if(sumall < k){
        cout << -1 << endl;
        return 0;
    }

    long long cl = 1; ///curr length
    curr = prefixrow[1][1];

    bool ok = true;

    for(long long x = 1; x+cl <= n+1 && ok; x++){
        copycurr = curr;
        for(long long y = 1; y+cl <= n+1 && ok; y++){
            if(copycurr < k){
                curr += prefixcol[cl][cl+1] + prefixrow[cl+1][cl+1];
                copycurr = copycurr + (prefixrow[y+cl][x+cl-1] - prefixrow[y+cl][x-1]) + (prefixcol[y+cl][x+cl] - prefixcol[y-1][x+cl]);
                y--;
                cl++;
                if(cl+x > n+1){
                    ok = false;
                }
            }else{
                copycurr = copycurr + (prefixrow[y+cl][x+cl-1] - prefixrow[y+cl][x-1]) - (prefixrow[y][x+cl-1] - prefixrow[y][x-1]);
            }
        }
        curr = curr - prefixcol[cl][x] + prefixcol[cl][x+cl];
    }

    cout << cl << endl;

return 0;
}
/*
5 10
1 2 3 4 5
10 0 7 0 4
0 0 2 1 3
5 0 3 0 2
0 5 0 8 0
*/
