#include <iostream>
using namespace std;
const int MAXN=5e3+2;
long long a[MAXN][MAXN], pr[MAXN][MAXN];
int dp[MAXN][MAXN], maxsq[MAXN];
long long k;
long long sum(int i1, int j1, int i2, int j2) {
    return pr[i1][j1]-pr[i1][j2-1]-pr[i2-1][j1]+pr[i2-1][j2-1];
}
int find_square(int i, int j) {
    int l, r, mid;
    l=1; r=min(i,j);
    while (l<=r) {
        mid=(l+r)/2;
        if (sum(i,j,i-mid+1,j-mid+1)>=k) r=mid-1;
        else l=mid+1;
    }
    return l;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n >> k;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=n;j++) {
            cin >> a[i][j];
            pr[i][j]=pr[i-1][j]+pr[i][j-1]-pr[i-1][j-1]+a[i][j];
        }
    }
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=n;j++) dp[i][j]=find_square(i,j);
    }
    maxsq[n+1]=0;
    int ans=-1, maxs;
    for (int i=n;i>=1;i--) {
        maxs=0;
        for (int j=i;j<=n;j++) maxs=max(maxs,max(dp[i][j],dp[j][i]));
        maxsq[i]=max(maxs,maxsq[i+1]);
        if (maxsq[i]==i) ans=i;
    }
    cout << ans << endl;
    return 0;
}
