#include <iostream>
using namespace std;
#define endl '\n'
const int MAXN=5e3+10;
long long pr[MAXN][MAXN];
int dp[MAXN][MAXN];
int row[MAXN][MAXN], col[MAXN][MAXN];
long long k;
int n;
long long sum(int i1, int j1, int i2, int j2) {
    return pr[i1][j1]-pr[i1][j2-1]-pr[i2-1][j1]+pr[i2-1][j2-1];
}
int find_square(int i, int j) {
    int l, r, mid;
    l=1; r=min(i,j);
    if (sum(i,j,i-r+1,j-r+1)<k) return -1;
    while (l<=r) {
        mid=(l+r)/2;
        if (sum(i,j,i-mid+1,j-mid+1)>=k) r=mid-1;
        else l=mid+1;
    }
    return l;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    long long a;
    cin >> n >> k;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=n;j++) {
            cin >> a;
            pr[i][j]=pr[i-1][j]+pr[i][j-1]-pr[i-1][j-1]+a;
            row[i][j]=row[i][j-1];
            col[i][j]=col[i-1][j];
            if (a>0) {
                row[i][j]++;
                col[i][j]++;
            }
        }
    }
    if (find_square(n,n)==-1) {
        ///cout << "No\n";
        cout << -1 << endl;
        return 0;
    }
    int ans=-1, minind, s;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=n;j++) {
            minind=min(i,j);
            if (sum(i,j,i-minind+1,j-minind+1)<k) {
                dp[i][j]=-1;
                ans=max(ans,minind+1);
                continue;
            }
            if (i>1 && j>1 && dp[i-1][j-1]>-1) s=dp[i-1][j-1]+1;
            else s=-1;
            if (s>-1 && row[i][j]-row[i][j-s]==0 && col[i][j]-col[i-s][j]==0) dp[i][j]=dp[i-1][j-1]+1;
            else dp[i][j]=find_square(i,j);
            if (dp[i][j]==-1) ans=max(minind+1,ans);
            else ans=max(ans,dp[i][j]);
        }
    }
    cout << ans << endl;
    /**
    maxsq[n+1]=0;
    int ans=-1, maxs;
    for (int i=n;i>=1;i--) {
        maxs=0;
        for (int j=i;j<=n;j++) maxs=max(maxs,max(dp[i][j],dp[j][i]));
        maxsq[i]=max(maxs,maxsq[i+1]);
        if (maxsq[i]<=i) ans=i;
    }
    cout << ans << endl;
    **/
    return 0;
}
/**
4 2
0 1 1 0
0 2 0 0
7 0 0 0
0 0 0 0
**/
