#include <iostream>

#define ull unsigned long long

ull gcd(ull a, ull b)
{
	while(b != 0)
	{
		ull r = a % b;
		a = b;
		b = r;
	}

	return a;
}

int main()
{

	ull a, b;
	std::cin >> a >> b;
	if(a > b)
	{
		std::swap(a, b);
	}

	if(a == b)
	{
		std::cout << "0\n";
		return 0;
	}

	ull aa, bb, g;

	g = gcd(a, b);
	bb = b / g;
	aa = a /g;

	ull k = (aa + bb - 1) / aa - 1;

	//std::cout << k << '\n';

	std::cout << std::min(k, a / bb) << '\n';

	return 0;
}