#include <algorithm>
#include <iostream>
#define endl '\n'
using namespace std;

long long x, y;

long long rec(long long A, long long B, bool t)
{
    if (A > B) swap(A, B);
    long long gcd = __gcd(A, B);
    if (gcd == 1 and !t) return 1;
    if (gcd == 1 and t) return 0;

    long long ans = 0;
    long long x, y;
    for (long long i = 1; i < gcd; ++ i)
    {
        x = A - i * A / gcd;
        y = B - i * B / gcd;
        if (x > y) swap(x, y);
        if (1ll * x * B != 1ll * A * y) ans += rec(i * A / gcd, i * B / gcd, !t);
        x = A - i * B / gcd;
        y = B - i * A / gcd;
        if (x > y) swap(x, y);
        if (!(x == 0 and y == 0) and x >= 0 and y >= 0 and 1ll * x * B != 1ll * A * y) ans += rec(i * B / gcd, i * A / gcd, !t);
    }

    if (!t)
    {
        if (ans == 0) return 1;
        else return 0;
    }

    return ans;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    long long A, B;
    cin >> A >> B;

    if (A == B)
    {
        cout << 0 << endl;
        return 0;
    }

    if (A > B) swap(A, B);

    cout << rec(A, B, true) << endl;

    return 0;
}
