#include <algorithm>
#include <iostream>
#pragma GCC optimize("Ofast")
#define endl '\n'
using namespace std;

bool rec(int A, int B, bool turn)
{
    unsigned long long int gcd = __gcd(A, B);
    if (gcd == 1 and !turn) return true;
    if (gcd == 1 and turn) return false;

    bool t;
    if (!turn) t = true;
    else t = false;
    unsigned long long int Agcd = A / gcd, Bgcd = B / gcd, x, y;
    for (unsigned long long int i = 1; i < gcd; ++ i)
    {
        if ((A - i * Agcd) * B != (B - i * Bgcd) * A)
        {
            if (!turn) t = (t & rec(i * Agcd, i * Bgcd, !turn));
            else t = (t | rec(i * Agcd, i * Bgcd, !turn));
        }
        if (i * Bgcd <= A and i * Agcd <= B)
        {
            x = A - i * Bgcd;
            y = B - i * Agcd;
            if (x > y) swap(x, y);
            if (x >= 0 and y > 0 and x * B != y * A)
            {
                if (!turn) t = (t & rec(i * Agcd, i * Bgcd, !turn));
                else t = (t | rec(i * Agcd, i * Bgcd, !turn));
            }
        }

        if (turn and t) break;
        if (!turn and !t) break;
    }

    return t;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    unsigned long long int A, B;
    cin >> A >> B;

    if (A == B)
    {
        cout << 0 << endl;
        return 0;
    }

    if (A > B) swap(A, B);

    int ans = 0;
    unsigned long long int gcd = __gcd(A, B);

    unsigned long long int Agcd = A / gcd, Bgcd = B / gcd, x, y;
    for (unsigned long long int i = 1; i < gcd; ++ i)
    {
        if ((A - i * Agcd) * B != (B - i * Bgcd) * A) ans += rec(i * Agcd, i * Bgcd, false);
        if (i * Bgcd <= A and i * Agcd <= B)
        {
            x = A - i * Bgcd;
            y = B - i * Agcd;
            if (x > y) swap(x, y);
            if (x >= 0 and y > 0 and x * B != y * A) ans += rec(i * Agcd, i * Bgcd, false);
        }
    }

    cout << ans << endl;

    return 0;
}
