#include <algorithm>
#include <iostream>
#include <map>
#define endl '\n'
using namespace std;

map< pair<unsigned long long int, bool> , bool> M;

unsigned long long int A, B, Agcd, Bgcd, gcd;

bool rec(unsigned long long int gcd1, bool turn)
{
    if (M.find(make_pair(gcd1, turn)) != M.end()) return M[make_pair(gcd1, turn)];

    if (gcd1 == 1 and !turn) return true;
    if (gcd1 == 1 and turn) return false;

    bool t;
    if (!turn) t = true;
    else t = false;
    unsigned long long int x, y;
    for (unsigned long long int i =gcd1 - 1; i > 0; -- i)
    {
        if ((gcd1 * Agcd - i * Agcd) * gcd1 * Bgcd != (gcd1 * Bgcd - i * Bgcd) * gcd1 * Agcd)
        {
            if (!turn) t = (t & rec(i, !turn));
            else t = (t | rec(i, !turn));
        }
        if (i * Bgcd <= gcd1 * Agcd and i * Agcd <= gcd1 * Bgcd)
        {
            x = gcd1 * Agcd - i * Bgcd;
            y = gcd1 * Bgcd - i * Agcd;
            if (x > y) swap(x, y);
            if (x >= 0 and y > 0 and x * gcd1 * Bgcd != y * gcd1 * Agcd)
            {
                if (!turn) t = (t & rec(i, !turn));
                else t = (t | rec(i, !turn));
            }
        }

        if (turn and t) break;
        if (!turn and !t) break;
    }

    M[make_pair(gcd1, turn)] = t;

    return t;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> A >> B;

    if (A == B)
    {
        cout << 0 << endl;
        return 0;
    }

    if (A > B) swap(A, B);

    int ans = 0;
    gcd = __gcd(A, B);

    Agcd = A / gcd, Bgcd = B / gcd;
    unsigned long long int x, y;
    for (unsigned long long int i = gcd - 1; i > 0; -- i)
    {
        if ((A - i * Agcd) * B != (B - i * Bgcd) * A) ans += rec(i, false);
        if (i * Bgcd <= A and i * Agcd <= B)
        {
            x = A - i * Bgcd;
            y = B - i * Agcd;
            if (x > y) swap(x, y);
            if (x >= 0 and y > 0 and x * B != y * A) ans += rec(i, false);
        }
    }

    cout << ans << endl;

    return 0;
}
