#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 5000;

long long sum[MAXN + 5][MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int N;
    long long K;
    cin >> N >> K;

    int num;
    for (int i = 1; i <= N; ++ i)
    {
        for (int j = 1; j <= N; ++ j)
        {
            cin >> num;
            sum[i][j] = sum[i - 1][j] + sum[i][j - 1] - sum[i - 1][j - 1] + num;
        }
    }

    bool t;
    long long s;
    for (int M = 1; M <= N; ++ M)
    {
        t = true;
        for (int i = 1; i <= N - M + 1 and t; ++ i)
        {
            for (int j = 1; j <= N - M + 1 and t; ++ j)
            {
                s = sum[i + M - 1][j + M - 1] - sum[i - 1][j + M - 1] - sum[i + M - 1][j - 1] + sum[i - 1][j - 1];
                if (s < K) t = false;
            }
        }

        if (t)
        {
            cout << M << endl;
            return 0;
        }
    }

    cout << -1 << endl;

    return 0;
}
