#include <iostream>
#include <stack>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;

int h[MAXN + 5];
int L[MAXN + 5], R[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int N;
    cin >> N;

    h[0] = h[N + 1] = 2 * MAXN + 5;
    stack<int> st;
    st.push(0);
    for (int i = 1; i <= N; ++ i)
    {
        cin >> h[i];
        while (h[st.top()] < h[i]) st.pop();
        L[i] = st.top();
        st.push(i);
    }

    while (!st.empty()) st.pop();

    st.push(N + 1);

    for (int i = N; i >= 1; -- i)
    {
        while (h[st.top()] < h[i]) st.pop();
        R[i] = st.top();
        st.push(i);
    }

    int K;
    cin >> K;

    int ans = 0;
    int idx, hh;
    for (int i = 0; i < K; ++ i)
    {
        cin >> idx >> hh;
        idx++;
        if (!(L[idx] == 0 and R[idx] == N + 1) and ((min(h[idx] + hh, h[L[idx]]) > min(h[idx], h[L[idx]]) and R[idx] == N + 1) or (min(h[idx] + hh, h[R[idx]]) > min(h[idx], h[R[idx]]) and L[idx] == 0)))
        {
            h[idx] += hh;
            ans++;
        }
    }

    while (!st.empty()) st.pop();

    st.push(0);
    for (int i = 1; i <= N; ++ i)
    {
        while (h[st.top()] < h[i]) st.pop();
        L[i] = st.top();
        st.push(i);
    }

    while (!st.empty()) st.pop();

    st.push(N + 1);

    for (int i = N; i >= 1; -- i)
    {
        while (h[st.top()] < h[i]) st.pop();
        R[i] = st.top();
        st.push(i);
    }

    int i = 1;
    unsigned long long int area = 0;
    while (R[i] != N + 1)
    {
        area += h[i] * (R[i] - i);
        i = R[i];
    }

    int j = N;
    while (j != i)
    {
        area += h[j] * (j - L[j]);
        j = L[j];
    }

    cout << ans << " " << area << endl;

    return 0;
}
