#include <bits/stdc++.h>

#define endl '\n'
#define range(i, a, b) for(int i = a; i < b; ++i)
#define squared(i, j, a, b) for(int i = a; i < b; ++i) for(int j = a; j < b; ++j)

typedef std::vector<std::vector<int>> int_matrix;
typedef long long ll;

int rect_sum(const std::vector<int>& arr, int x, int m)
{
    auto sum = 0;

    auto n = sqrt(arr.size());

    if(x + (n + 1) * (m - 1) > arr.size()) { // Bottom right corner out of array
        return -1;
    }

    range(i, 0, m) {
        range(j, 0, m) {
            auto curr_idx = x + (i * n + j);
            sum += arr[curr_idx];
        }
    }

    return sum;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, k;
    std::cin >> n >> k;

    std::vector<int> arr(n * n);

    range(i, 0, n*n) {
        std::cin >> arr[i];
    }

    range(m, 1, n+1) {
        auto success = true;

        range(i, 0, n*n) {
            auto sum = rect_sum(arr, i, m);
            if(sum == -1) {
                continue;
            }

            if(sum < k) {
                success = false;
                break;
            }
        }

        if(success) {
            std::cout << m << endl;
            break;
        }
    }

    return 0;
}
