#include <bits/stdc++.h>

#define endl '\n'
#define range(i, a, b) for(ll i = a; i < b; ++i)

typedef unsigned long long ll;

ll rect_sum(const std::vector<ll>& arr, ll x, ll m)
{
    auto sum = 0;

    auto n = std::sqrt(arr.size());

    if(x + (n + 1) * (m - 1) > arr.size()) { // Bottom right corner out of array
        return -1;
    }

    range(i, 0, m) {
        range(j, 0, m) {
            auto curr_idx = x + (i * n + j);
            sum += arr[curr_idx];
        }
    }

    return sum;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    ll n, k;
    std::cin >> n >> k;

    std::vector<ll> arr(n * n);

    range(i, 0, n*n) {
        std::cin >> arr[i];
    }

    bool success;
    range(m, 1, n+1) {
        success = true;

        range(i, 0, n*n) {
            auto sum = rect_sum(arr, i, m);
            if(sum == -1) {
                continue;
            }

            if(sum < k) {
                success = false;
                break;
            }
        }

        if(success) {
            std::cout << m << endl;
            break;
        }
    }

    if(!success) {
        std::cout << "-1" << endl;
    }

    return 0;
}
