#include <iostream>
#include <bitset>
#include <stack>
using namespace std;
#define endl '\n'
#define MAXN int(1e6 + 5)
int br, offers, maximum, global, elim;
int arr[MAXN], height[MAXN];
bitset<MAXN> bs;
stack<int> st;
inline void update(int from, int to, int value)
{
    for(int i = from; i <= to; ++i){
        global -= height[i];
        height[i] = value;
        global += height[i];
        if(i != from){
            if(bs[i] == 1){
                ++elim; bs[i] = 0;
            }
        }
    }
}
int main()
{
    //cin.tie(0); ios::sync_with_stdio(false);
    cin >> br;
    for(int i = 0; i < br; ++i){
        cin >> arr[i];
    }
    cin >> offers;
    for(int i = 0; i < offers; ++i){
        int index, value; cin >> index >> value;
        arr[index] += value; bs[index] = 1;
    }
    st.push(0); maximum = 0;
    for(int i = 1; i < br; ++i){
        if(arr[i] > arr[maximum]){
            //cout << "FIRST CASE " << i << ' ' << maximum << endl;
            while(st.top() != maximum){
                st.pop();
            }
            update(maximum, i - 1, arr[maximum]);
            maximum = i;
            st.pop(); st.push(i);
        }
        else{
            //cout << "SECOND CASE " << i << ' ';
            while(arr[st.top()] < arr[i]){
                st.pop();
            }
            int hat = st.top();
           // cout << hat << endl;
            update(hat, i - 1, arr[i]);
            st.push(i);
        }
    }
    cout << offers - elim << ' ' << global << endl;
    /*for(int i = 0; i < br; ++i){
        cout << height[i] << ' ';
    }
    cout << endl;*/
    return 0;
}
