#include <iostream>
#include <algorithm>
#include <stack>

using namespace std;

struct Q {
  int poz, add;
  bool operator < (const Q &other) const {
    return poz < other.poz;
  }
} q[1000005];

int n, k;
long long ans;

int h[1000005], tmp[1000005], lim[1000005], lim2[1000005];
stack <int> st;

/*void update(int nod, int l, int r, int index, int val) {
  if(l == r) {
    aint[nod] = val;
    return;
  }
  int mid = (l + r) >> 1;
  if(index <= mid)
    update(2 * nod, l, mid, index, val);
  else
    update(2 * nod + 1, mid + 1, r, index, val);
  aint[nod] = max(aint[2 * nod], aint[2 * nod + 1]);
}

int query(int nod, int l, int r, int st, int dr) {
  if(st <= l && r <= dr)
    return aint[nod];
  int mid = (l + r) >> 1, a = 0, b = 0;
  if(st <= mid)
    a = query(2 * nod, l, mid, st, dr);
  if(mid < dr)
    b = query(2 * nod + 1, mid + 1, r, st, dr);
  return max(a, b);
}*/

int main() {
  ios_base :: sync_with_stdio(false);
  cin.tie(0);
  cin >> n;
  for(int i = 1; i <= n; i++)
    cin >> h[i], tmp[i] = h[i];
  cin >> k;
  int cnt = 0;
  for(int i = 1; i <= k; i++) {
    cin >> q[i].poz >> q[i].add;
    q[i].poz++;
    h[q[i].poz] += q[i].add;
  }
  sort(q + 1, q + k + 1);
  for(int i = n; i >= 1; i--) {
    while(!st.empty() && h[i] > h[st.top()])
      st.pop();
    if(!st.empty())
      lim[i] = st.top();
    st.push(i);
  }
  while(!st.empty())
    st.pop();
  for(int i = 1; i <= n; i++) {
    while(!st.empty() && h[i] > h[st.top()])
      st.pop();
    if(!st.empty())
      lim2[st.top()] = i;
    st.push(i);
  }
  int p = 1;
  while(p < n) {
    if(lim[p]) {
      ans += 1LL * min(h[p], h[lim[p]]) * (lim[p] - p);
      p = lim[p];
    } else {
      ans += 1LL * min(h[p], h[lim2[p]]) * (lim2[p] - p);
      p = lim2[p];
    }
  }
  p = 1;
  int j = 1;
  while(p < n) {
    if(lim[p]) {
      int x = lim[p], p2 = p;
      if(q[j].poz == p)
        cnt += h[q[j].poz] - tmp[q[j].poz], j++;
      p++;
      while(p < x) {
        if(q[j].poz == p)
          j++;
        p++;
      }
    } else {
      int x = lim2[p];
      p++;
      while(p < x) {
        if(q[j].poz == p)
          j++;
        p++;
      }
      if(q[j].poz == p)
        cnt += h[q[j].poz] - tmp[q[j].poz], j++;
    }
  }
  cout << cnt << " " << ans;
  return 0;
}
