#include <iostream>
#include <algorithm>

using namespace std;

long long x, y, z, A, B;

long long dp[2005][2005];

long long getAns(long long x, long long y, long long A, long long B) {
  long long ans = 0;
  if(x < B || y < A) {
    return 1;
  }
  if(dp[x][y])
    return dp[x][y];
  for(int i = 1; i <= x / B && i <= y / A; i++)
    ans += getAns(i * B, i * A, B, A);
  dp[x][y] = dp[y][x] = ans;
  return ans;
}

int main() {
  cin >> x >> y;
  z = __gcd(x, y);
  if(z == 1 || x == y) {
    cout << 0;
    return 0;
  }
  A = x / z, B = y / z;
  cout << getAns(x, y, A, B);
  return 0;
}
