#include <iostream>
#include <cassert>

using namespace std;

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 1000000;
int v[1 + nmax];
int increase[1 + nmax];
int pref[1 + nmax], suff[1 + nmax];
int crescut[1 + nmax];
int minval[1 + nmax];

int main()
{
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int n, k;
  cin >> n;
  for(int i = 1; i <= n; i++)
    cin >> v[i];
  cin >> k;
  for(int i = 1;i <= k; i++){
    int pos, val;
    cin >> pos >> val;
    pos++;
    assert(increase[pos] == 0);
    increase[pos] = val;
  }
  for(int i = 1;i < n; i++)
    pref[i] = MAX(pref[i - 1], v[i] + increase[i]);
  for(int i = n - 1;1 <= i; i--)
    suff[i] = MAX(suff[i + 1], v[i + 1] + increase[i + 1]);

  ll result = 0, result2 = 0;
  for(int i = 1; i < n; i++) {
    minval[i] = min(pref[i], suff[i]);
    result += minval[i];
  }

  int valmax = 0;
  for(int i = 1;i < n; i++) {
    if(crescut[i] == 0){
      if(max(valmax, v[i]) < minval[i]){
        crescut[i] = 1;
        result2++;
        valmax = max(valmax, v[i] + increase[i]);
      } else
        valmax = max(valmax, v[i]);
    } else
      valmax = max(valmax, v[i] + increase[i]);
  }
  valmax = 0;

  for(int i = n - 1; 1 <= i; i--){
    if(crescut[i + 1] == 0){
      if(max(valmax, v[i + 1]) < minval[i]){
        crescut[i + 1] = 1;
        result2++;
        valmax = max(valmax, v[i + 1] + increase[i + 1]);
      } else
        valmax = max(valmax, v[i + 1]);
    } else
      valmax = max(valmax, v[i + 1] + increase[i + 1]);
  }
  cout << result2 << " " << result << '\n';
  return 0;
}
