#include <iostream>
#include <cstdio>

using namespace std;

typedef long long ll;
const int N = 2000 + 7;
int a;
int b;
bool w[N][N];
int c[N][N];
double rap;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> a >> b;
    rap = (double) min(a, b) / (double) max(a, b);
    for (int x = 0; x <= a; x++)
    {
        for (int y = 0; y <= b; y++)
        {
            w[x][y] = 0;
            for (int i = 0; i <= x; i++)
            {
                for (int j = 0; j <= y; j++)
                {
                    if (i > 0 || j > 0)
                    {
                        double r = (double) min(i, j) / (double) max(i, j);
                        if (r != rap && w[x - i][y - j] == 0)
                        {
                            w[x][y] = 1;
                            c[x][y]++;
                        }
                    }
                }
            }
        }
    }
    cout << c[a][b] << "\n";
}

