#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
const int N = (int) 1e6 + 7;
int n;
ll h[N];
ll grow[N];
vector<int> a;
vector<int> b;
int pivot;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

   // freopen ("input", "r", stdin);
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> h[i];
    }
    int q;
    cin >> q;
    for (int i = 1; i <= q; i++)
    {
        int j;
        ll x;
        cin >> j >> x;
        j++;
        grow[j] += x;
        h[j] += x;
    }
    ll mx = 0;
    for (int i = 1; i <= n; i++)
    {
        mx = max(mx, h[i]);
        if (h[i] == mx)
        {
            a.push_back(i);
        }
    }
    pivot = a.back();
    mx = 0;
    for (int i = n; i >= pivot; i--)
    {
        mx = max(mx, h[i]);
        if (h[i] == mx)
        {
            b.push_back(i);
        }
    }
    reverse(b.begin(), b.end());
    ll ans = 0;
    for (int i = 0; i + 1 < (int) a.size(); i++)
    {
        ans += h[a[i]] * (a[i + 1] - a[i]);
    }
    for (int i = 0; i + 1 < (int) b.size(); i++)
    {
        ans += h[b[i + 1]] * (b[i + 1] - b[i]);
    }
    ll cost = 0;
    for (int i = 0; i + 1 < (int) a.size(); i++)
    {
        cost += grow[a[i]];
    }
    for (int i = 0; i + 1 < (int) b.size(); i++)
    {
        cost += grow[b[i]];
    }
    cout << cost << " " << ans << "\n";
}
