#include <iostream>

using namespace std;

int n, k;
int a[5005][5005];
int sp[5005][5005];

void Precalculare()
{
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            sp[i][j] = sp[i-1][j] + sp[i][j-1] - sp[i-1][j-1] + a[i][j];
}

int sum_patrat(int i, int j, int m)
{
    return sp[i][j] - sp[i-m][j] - sp[i][j-m] + sp[i-m][j-m];
}

int main()
{
    cin >> n >> k;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            cin >> a[i][j];
        }
    }

    int sol = 1;

    Precalculare();

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            if (i < sol || j < sol) continue;

            while (i >= sol && j >= sol && sol <= n && sum_patrat(i, j, sol) < k) sol++;
        }
    }

    cout << (sol > n ? -1 : sol) << '\n';
    return 0;
}
