#include <iostream>

using namespace std;

int n;
long long k;
int a[5005][5005];
long long sp[5005][5005];

void Precalculare()
{
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            sp[i][j] = sp[i-1][j] + sp[i][j-1] - sp[i-1][j-1] + a[i][j];
}

long long sum_patrat(int i, int j, int m)
{
    return sp[i][j] - sp[i-m][j] - sp[i][j-m] + sp[i-m][j-m];
}

int main()
{
    cin >> n >> k;

    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            cin >> a[i][j];

    Precalculare();

    if (sum_patrat(n, n, n) < k)
    {
        cout << -1 << '\n';
        return 0;
    }

    int sol = 1;
    int i = 0, j = 0;

    for (i = 1; i <= n; ++i)
    {
        for (j = 1; j <= n; ++j)
        {
            while (i >= sol && j >= sol && sol <= n && sum_patrat(i, j, sol) < k) sol++;

            if (j < sol) j = sol - 1;
            if (i < sol) i = sol;
        }
    }

    cout << sol << '\n';

    return 0;
}
