#include <iostream>

using namespace std;

int n;
int k;
int a[5005][5005];
int sp[5005][5005];

int sum_patrat(int i, int j, int m)
{
    return sp[i][j] - sp[i-m][j] - sp[i][j-m] + sp[i-m][j-m];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> k;

    int sol = 0;

    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
        {
            cin >> a[i][j];
            sp[i][j] = sp[i-1][j] + sp[i][j-1] + a[i][j] - sp[i-1][j-1];

            while (sol <= min(i, j) && sum_patrat(i, j, sol) < k) sol++;
        }

    if (sol > n)
    {
        cout << -1 << '\n';
        return 0;
    }

    cout << sol << '\n';

    return 0;
}
