#include <iostream>
#include <deque>

using namespace std;

constexpr int NMAX = 1e6 + 5;

int n, k;
long long lg[NMAX];

long long cresc[NMAX];

deque <int> D;

long long sol = 0;
int nr_k = 0;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> lg[i];

    cin >> k;
    for (int i = 1; i <= k; ++i)
    {
        int x, y;
        cin >> x >> y;

        x++;
        cresc[x] += y;
        lg[x] += y;
    }

    nr_k = k;
    D.push_back(1);

    for (int i = 2; i <= n; ++i)
    {
        int x = D.front();

        while (!D.empty() && lg[D.back()] < lg[i])
        {
            if (cresc[D.back()] > 0)
            {
                nr_k--;
                lg[D.back()] -= cresc[D.back()];
            }
            D.pop_back();
        }

        if (D.empty())
        {
            sol = sol + 1LL * lg[x] * (i - x);
            if (cresc[x] > 0)
            {
                nr_k++;
                lg[x] += cresc[x];
            }
        }

        int last = 0;

        while (!D.empty() && lg[D.back()] == lg[i])
        {
            last = D.back();
            if (cresc[D.back()] > 0)
            {
                nr_k--;
                lg[D.back()] -= cresc[D.back()];
            }
            D.pop_back();
        }

        if (last != 0 && D.empty())
        {
            D.push_back(last);
            if (cresc[last] > 0)
            {
                nr_k++;
                lg[last] += cresc[last];
            }
        }
        D.push_back(i);
    }

    if (D.size() == 1 || (lg[D[0]] != lg[D[1]]))
    {
        long long Maxst = 0;
        long long Maxdr = 0;

        for (int i = 1; i < D[0]; ++i)
            Maxst = max(Maxst, lg[i]);
        for (int i = D[0]+1; i <= n; ++i)
            Maxdr = max(Maxdr, lg[i]);

        if ((D[0] == 1 && Maxdr >= lg[D[0]] - cresc[D[0]]) || Maxst == Maxdr || (D[0] == n && Maxst >= lg[D[0]] - cresc[D[0]]))
        {
            nr_k--;
            lg[D[0]] -= cresc[D[0]];
        }
    }

    for (int i = 1; i < D.size(); ++i)
    {
        int x = D[i];
        sol = sol + 1LL * lg[x] * (D[i] - D[i-1]);
    }

    cout << nr_k << " " << sol << '\n';
    return 0;
}
