#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 5002;

const int BUFFER_SIZE = 1000000;

char buffer[BUFFER_SIZE];
int bpos = BUFFER_SIZE - 1;

bool isd[] =
{
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0
};

char read_char ()
{
    bpos++;
    if(bpos == BUFFER_SIZE)
    {
        fread(buffer, sizeof(char), BUFFER_SIZE, stdin);
        bpos = 0;
    }
    return buffer[bpos];
}

int read_int ()
{
    char c;
    while(!isd[c = read_char()]);
    int ans = 0;
    while(isd[c])
    {
        ans = ans * 10 + c - '0';
        c = read_char();
    }
    return ans;
}

int n, k;

int ma[N_MAX][N_MAX];

ll sp[N_MAX][N_MAX];

int c[N_MAX][N_MAX];

ll sum (int xa, int ya, int xb, int yb)
{
    xb = min(xb, n);
    yb = min(yb, n);
    return sp[xb][yb] - sp[xa - 1][yb] - sp[xb][ya - 1] + sp[xa - 1][ya - 1];
}

int mars[N_MAX];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    n = read_int();
    k = read_int();
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
        {
            ma[i][j] = read_int();
            sp[i][j] = sp[i - 1][j] + sp[i][j - 1] - sp[i - 1][j - 1] + ma[i][j];
        }
    for(int d = 1; d <= n; d++)
    {
        for(int i = 1, j = d; j <= n; i++, j++)
        {
            c[i][j] = max(1, c[i - 1][j - 1] - 1);
            while(c[i][j] <= n && sum(i, j, i + c[i][j] - 1, j + c[i][j] - 1) < k)
                c[i][j]++;
        }
        if(d == 1)
            continue;
        for(int i = d, j = 1; i <= n; i++, j++)
        {
            c[i][j] = max(1, c[i - 1][j - 1] - 1);
            while(c[i][j] <= n && sum(i, j, i + c[i][j] - 1, j + c[i][j] - 1) < k)
                c[i][j]++;
        }
    }
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
            mars[min(n - i + 1, n - j + 1)] = max(mars[min(n - i + 1, n - j + 1)], c[i][j]);
    for(int i = n; i >= 1; i--)
        mars[i] = max(mars[i], mars[i + 1]);
    for(int i = 1; i <= n; i++)
        if(mars[i] <= i)
        {
            cout << i << "\n";
            return 0;
        }
    cout << "-1\n";
    return 0;
}
