#include <bits/stdc++.h>

using namespace std;

void solve();

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

int n, k, a[5001][5001], inf = 2e9;

int sum(int x, int y, int m) {
    int res = 0;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            res += a[i + x][j + y];
        }
    }
    return res;
}

bool good(int m) {
    int res = inf;
    for (int i = 0; i < n - m + 1; i++) {
        for (int j = 0; j < n - m + 1; j++) {
            res = min(res, sum(i, j, m));
        }
    }
    return res >= k;
}

void solve() {
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    int l = 0, r = n + 1;
    while (l + 1 < r) {
        int m = (r + l) / 2;
        if (good(m)) r = m;
        else l = m;
    }
    if (r == n + 1) cout << -1;
    else cout << r << endl;
}
