#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <numeric>


#define all(v) v.begin(), v.end()
#define ll long long
#define ld long double
#define trace(x) cout << " x : " << x << endl;


using namespace std;

const int inf = 1e9;
const int mod = 1e9 + 7;

const int maxn = 1e6;

int h[maxn];
int pref[maxn];
int suf[maxn];


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    for(int i = 0; i < n; ++i){
        cin >> h[i];
    }
    for(int i = 0; i < k; ++i){
        int ind, add;
        cin >> ind >> add;
        h[ind] += add;
    }
    pref[0] = h[0];
    for(int i = 1; i < n; ++i){
        pref[i] = max(pref[i - 1], h[i]);
    }
    suf[n-1] = h[n-1];
    for(int i = n - 2; i >= 0; --i){
        suf[i] = max(suf[i + 1], h[i]);
    }
    int ans = 0;
    for(int i = 0; i < n - 1; ++i) {
        ans += min(pref[i], suf[i + 1]);
    }
    cout << k << " " << ans;
}
