#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <numeric>


#define all(v) v.begin(), v.end()
#define ll long long
#define ld long double
#define trace(x) cout << " x : " << x << endl;


using namespace std;

#define int long long

const int inf = 1e9;
const int mod = 1e9 + 7;

const int maxn = 10;

int h[maxn];
int a[maxn], ind[maxn];
int pref[maxn];
int suf[maxn];


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, k;
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> h[i];
    }
    cin >> k;
    for(int i = 0; i < k; ++i){
        cin >> ind[i];
        cin >> a[i];
        h[ind[i]] += a[i];
    }
    int cnt = k;
    pref[0] = h[0];
    for(int i = 1; i < n; ++i){
        pref[i] = max(pref[i - 1], h[i]);
    }
    suf[n-1] = h[n-1];
    for(int i = n - 2; i >= 0; --i){
        suf[i] = max(suf[i + 1], h[i]);
    }
    int mx = 0;
    for(int i = 0; i < n - 1; ++i) {
        mx += min(pref[i], suf[i + 1]);
    }
    for(int b = 0; b < k; ++b) {
        h[ind[b]] -= a[b];
        pref[0] = h[0];
        for(int i = 1; i < n; ++i){
            pref[i] = max(pref[i - 1], h[i]);
        }
        suf[n-1] = h[n-1];
        for(int i = n - 2; i >= 0; --i){
            suf[i] = max(suf[i + 1], h[i]);
        }
        int ans = 0;
        for(int i = 0; i < n - 1; ++i) {
            ans += min(pref[i], suf[i + 1]);
        }
        if(ans == mx){
            cnt--;
        }
        h[ind[b]] += a[b];
    }
    cout << cnt << " " << mx;
}
