#include <bits/stdc++.h>
using namespace std;

#define int long long
typedef long long ll;
typedef long double ldb;




signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, k;
	cin >> n >> k;
	vector<vector<int>> arr(n, vector<int> (n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> arr[i][j];
		}
	}
	int sum = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			sum += arr[i][j];
		}
	}
	if (sum < k) {
		cout << -1 << endl;
		return 0;
	}
	int l = 0;
	int r = n;
	while (r - l > 1) {
		int m = l + (r - l) / 2;
		vector<vector<int>> arr2(n + 1, vector<int> (n + 1));
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				int i1 = i - m + 1;
				int j1 = j - m + 1;
				i1 = max(0LL, i1);
				j1 = max(0LL, j1);
				int i2 = i + 1;
				int j2 = j + 1;
				arr2[i1][j1] += arr[i][j];
				arr2[i2][j1] -= arr[i][j];
				arr2[i1][j2] -= arr[i][j];
				arr2[i2][j2] += arr[i][j];
			}
		}
		vector<vector<int>> arr3(n, vector<int> (n));
		int mn = LLONG_MAX;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				arr3[i][j] = arr2[i][j];
				if (i) {
					arr3[i][j] += arr3[i - 1][j];
				}
				if (j) {
					arr3[i][j] += arr3[i][j - 1];
				}
				if (i > 0 && j > 0) {
					arr3[i][j] += arr[i - 1][j - 1];
				}
				if (i <= n - m && j <= n - m)
					mn= min(mn, arr3[i][j]);
			}
		}
		if (mn < k) {
			l = m;
		} else {
			r = m;
		}
	}
	cout << r << endl;
	return 0;
}
