#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,popcnt,tune=native")
#include <bits/stdc++.h>
using namespace std;

//#define int long long
typedef long long ll;
typedef long double ldb;

const int MAXN = 5000 + 228;
int arr[MAXN][MAXN];
int arr2[MAXN][MAXN];

FILE *f;

char buf[4096];
int pos = 4096;

char getcc() {
	if (pos == 4096) {
		fread(buf, 1, 4096, f);
		pos = 0;
	}
	return buf[pos++];
}

int getInt() {
	int cur = 0;
	char c = getcc();
	while (!('0' <= c && c <= '9')) {
		c = getcc();
	}
	while ('0' <= c && c <= '9') {
		cur *= 10;
		cur += c - '0';
		c = getcc();
	}
	return cur;
}




signed main() {
	f = fopen("input.txt", "r");
	//ios_base::sync_with_stdio(0);
	//cin.tie(0);
	//cout.tie(0);
	int n, k;
	n = getInt();
	k = getInt();
	//scanf("%d %d", &n, &k);
	//cin >> n >> k;
	//vector<vector<int>> arr(n, vector<int> (n));
	//vector<vector<int>> arr2(n, vector<int> (n));
	//vector<vector<int>> arr2(n + 1, vector<int> (n + 1));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			//scanf("%d", &arr[i][j]);
			arr[i][j] = getInt();
			//cin >> arr[i][j];
		}
	}
	//return 0;
	int sum = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			sum += arr[i][j];
		}
	}
	if (sum < k) {
		cout << -1 << endl;
		return 0;
	}
	//cout << clock() << " " << CLOCKS_PER_SEC << endl;
	int l = 0;
	int r = n;
	while (r - l > 1) {
		memset(arr2, 0, sizeof(arr2));

		int m = l + (r - l) / 2;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				int i1 = i - m + 1;
				int j1 = j - m + 1;
				if (i1 < 0)
					i1 = 0;
				if (j1 < 0)
					j1 = 0;
				int i2 = i + 1;
				int j2 = j + 1;
				arr2[i1][j1] += arr[i][j];
				arr2[i2][j1] -= arr[i][j];
				arr2[i1][j2] -= arr[i][j];
				arr2[i2][j2] += arr[i][j];
			}
		}
		int mn = INT_MAX;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				arr2[i + 1][j] += arr2[i][j];
				arr2[i][j + 1] += arr2[i][j];
				arr2[i + 1][j + 1] -= arr2[i][j];
				/*arr2[i][j] = arr2[i][j];
				if (i) {
					arr2[i][j] += arr3[i - 1][j];
				}
				if (j) {
					arr2[i][j] += arr3[i][j - 1];
				}
				if (i > 0 && j > 0) {
					arr2[i][j] -= arr3[i - 1][j - 1];
				}*/
				if (i <= n - m && j <= n - m && arr2[i][j] < mn)
					mn= arr2[i][j];
			}
		}
		if (mn < k) {
			l = m;
		} else {
			r = m;
		}
	}
	cout << r << endl;
	return 0;
}
