#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,ssse3,popcnt,mmx,abm,tune=native")
using namespace std;

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    int a[n][n];
    for(int i = 0;i < n;i++) {
        for(int j = 0;j < n;j++) cin >> a[i][j];
    }
    int pref[n + 1][n + 1];
    for(int i = 0;i <= n;i++) {
        pref[i][0] = 0;
        pref[0][i] = 0;
    }

    for(int i = 1;i <= n;i++) {
        for(int j = 1;j <= n;j++) {
            pref[i][j] = pref[i][j - 1] + pref[i - 1][j] - pref[i - 1][j - 1] + a[i - 1][j - 1];
            //cout << pref[i][j] << " ";
        }
        //cout << '\n';
    }

    int l = -1;
    int r = n + 1;
    while(r - l > 1) {
        int mid = ((l + r) >> 1);
        bool bad = false;
        for(int i = mid;i <= n;i++) {
            for(int j = mid;j <= n;j++) {
                long long num = 0;
                num = pref[i][j] - pref[i][j - mid] - pref[i - mid][j] + pref[i - mid][j - mid];

                if (num < k) bad = true;
                if (bad) break;
            }
            if (bad) break;
        }
        if (bad) l = mid;
        else r = mid;
    }
    if (r == 0) cout << 1;
    else if (r == n + 1) cout << -1;
    else cout << r;
}
