#include <bits/stdc++.h>
using namespace std;

const int MAXN = 5e3 + 1;
int pref[MAXN][MAXN];
int k;

bool check(int i, int j, int m) {
    int res = pref[i + m][j + m] + pref[i][j];
    res -= pref[i + m][j] + pref[i][j + m];
    return res >= k;
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            int x;
            cin >> x;
            pref[i + 1][j + 1] = pref[i + 1][j] + pref[i][j + 1] - pref[i][j];
            pref[i + 1][j + 1] += x;
        }
    }
    int ans = -1;
    for (int d = -n + 1; d <= n - 1; ++d) {
        int cur = 1;
        for (int i = min(n - 1, n - 1 + d); i >= max(0, d); --i) {
            cur++;
            int j = i - d;
            while (check(i, j, cur - 1)) {
                cur--;
            }
            ans = max(ans, cur);
        }
    }
    if (ans == n + 1) {
        cout << -1;
    } else {
        cout << ans;
    }
    return 0;
}
