#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
//#define int ll
//#define double ld
#define endl '\n'
#define mp make_pair
#define pb emplace_back

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

const int MAX_MEM = 5e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new(size_t x)
{
    auto ret = MEM + CUR_MEM;
    CUR_MEM += x;
    return ret;
}
void operator delete(void*){}

template <class T>
istream& operator>> (istream &in, vector <T> &a) {for (auto &i : a) in >> i; return in;}
template <class T>
ostream& operator<< (ostream &out, vector <T> a) {for (auto &i : a) out << i << " "; return out;}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a) {in >> a.first >> a.second; return in;}
template <class T, class U>
ostream& operator<< (ostream &out, pair <T, U> a) {out << a.first << " " << a.second; return out;}

inline void Start()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}
using namespace __gnu_pbds;
using superset = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

signed main()
{
    Start();
    int n, k;
    cin >> n >> k;
    int a[n][n];
    int sum = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            cin >> a[i][j];
            sum += a[i][j];
        }
    }
    if (sum < k)
        return cout << -1, 0;
    vector <vector <int>> pref(n, vector <int> (n));
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            pref[i][j] = (i ? pref[i - 1][j] : 0) + (j ? pref[i][j - 1] : 0) - (i && j ? pref[i - 1][j - 1] : 0) + a[i][j];
        }
    }
    auto get = [&] (int x1, int y1, int x2, int y2)
    {
        return pref[x2][y2] - (x1 ? pref[x1 - 1][y2] : 0) - (y1 ? pref[x2][y1 - 1] : 0) + (x1 && y1 ? pref[x1 - 1][y1 - 1] : 0);
    };
    int l = 0, r = n;
    while (r - l > 1)
    {
        int x = (l + r) >> 1;
        for (int i = 0; i + x <= n; ++i)
        {
            for (int j = 0; j + x <= n; ++j)
            {
                if (get(i, j, i + x - 1, j + x - 1) < k)
                {
                    l = x;
                    goto brek;
                }
            }
        }
        r = x;
        brek:;
    }
    cout << r;
    return 0;
}
