#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
#define int ll
//#define double ld
//#define endl '\n'
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;
/*
const int MAX_MEM = 5e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new(size_t x)
{
    auto ret = MEM + CUR_MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete(void*){}
*/
template <class T>
istream& operator>> (istream &in, vector <T> &a) {for (auto &i : a) in >> i; return in;}
template <class T>
ostream& operator<< (ostream &out, vector <T> a) {for (auto &i : a) out << i << " "; return out;}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a) {in >> a.first >> a.second; return in;}
template <class T, class U>
ostream& operator<< (ostream &out, pair <T, U> a) {out << a.first << " " << a.second; return out;}

inline void Start()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}
using namespace __gnu_pbds;
using superset = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18;
void relax(pll &a, pll b)
{
    if (a.first < b.first)
        a = b;
    else if (a.first == b.first && a.second > b.second)
        a = b;
}

signed main()
{
    Start();
    int n, k;
    cin >> n;
    vector <int> h(n);
    cin >> h;
    vector <int> nh = h;
    cin >> k;
    for (int i = 0; i < k; ++i)
    {
        int p, x;
        cin >> p >> x;
        nh[p] += x;
    }
    vector <vector <pll>> dp(n, vector <pll> (2, mp(-INF, INF)));
    dp[0][0] = {0, 0};
    dp[0][1] = {0, 1};
    for (int i = 1; i < n; ++i)
    {
        ll maxi = -INF;
        for (int j = i - 1; j >= 0; --j)
        {
            for (int f1 = 0; f1 < 2; ++f1)
            {
                for (int f2 = 0; f2 < 2; ++f2)
                {
                    int a = f1 ? nh[i] : h[i], b = f2 ? nh[j] : h[j];
                    if (min(a, b) < maxi)
                        continue;
                    relax(dp[i][f1], mp(dp[j][f2].first + (i - j) * min(f1 ? nh[i] : h[i], f2 ? nh[j] : h[j]), dp[j][f2].second + f1));
                }
            }
            maxi = max(maxi, h[j]);
        }
    }
    pll ans = {-INF, INF};
    relax(ans, dp[n - 1][0]);
    relax(ans, dp[n - 1][1]);
    cout << ans.second << " " << ans.first;
    return 0;
}
