#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
#define int ll
//#define double ld
//#define endl '\n'
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;
/*
const int MAX_MEM = 5e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new(size_t x)
{
    auto ret = MEM + CUR_MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete(void*){}
*/
template <class T>
istream& operator>> (istream &in, vector <T> &a) {for (auto &i : a) in >> i; return in;}
template <class T>
ostream& operator<< (ostream &out, vector <T> a) {for (auto &i : a) out << i << " "; return out;}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a) {in >> a.first >> a.second; return in;}
template <class T, class U>
ostream& operator<< (ostream &out, pair <T, U> a) {out << a.first << " " << a.second; return out;}

inline void Start()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}
using namespace __gnu_pbds;
using superset = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

template <class T>
T gcd(T a, T b)
{
    return __gcd(a, b);
}

signed main()
{
    Start();
    int a, b;
    cin >> a >> b;
    if (a > b)
        swap(a, b);
    int x = a / gcd(a, b), y = b / gcd(a, b);
    int ans = 0;
    for (int takea = 0; takea < a; ++takea)
    {
        int na = a - takea;
        if (na * x % y == 0)
        {
            int nb = na * x / y;
            int takeb = b - nb;
            /// a < b
            /// na > nb // bruteforce
            /// -na < -nb
            /// a - na < b - nb
            /// takea < takeb so if min/max==x/y <=> takea == min, takeb == max;
            int g = gcd(takea, takeb);
            takea /= g;
            takeb /= g;
            if (takea != x || takeb != y)
                ++ans;
        }
    }
    cout << ans;
    return 0;
}
