#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
//#define int ll
//#define double ld
//#define endl '\n'
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;
/*
const int MAX_MEM = 5e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new(size_t x)
{
    auto ret = MEM + CUR_MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete(void*){}
*/
template <class T>
istream& operator>> (istream &in, vector <T> &a) {for (auto &i : a) in >> i; return in;}
template <class T>
ostream& operator<< (ostream &out, vector <T> a) {for (auto &i : a) out << i << " "; return out;}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a) {in >> a.first >> a.second; return in;}
template <class T, class U>
ostream& operator<< (ostream &out, pair <T, U> a) {out << a.first << " " << a.second; return out;}

inline void Start()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}
using namespace __gnu_pbds;
using superset = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

template <class T>
T gcd(T a, T b)
{
    return __gcd(a, b);
}
vector <vector <int>> calc(int a, int b)
{
    if (a > b)
        swap(a, b);
    vector <vector <int>> dp(a + 1, vector <int> (b + 1));
    for (int i = 0; i <= a; ++i)
    {
        for (int j = 0; j <= b; ++j)
        {
            if (!i && !j)
                continue;
            int cnt = 0;
            for (int ti = 0; ti <= i; ++ti)
            {
                for (int tj = 0; tj <= j; ++tj)
                {
                    int mi = min(ti, tj);
                    int ma = max(ti, tj);
                    if (mi * b == a * ma)
                    {
                        continue;
                    }
                    if (dp[i - ti][j - tj] == 0)
                        cnt++;
                }
            }
            if (cnt)
                dp[i][j] = 1;
        }
    }
    return dp;
}

int sol(int a, int b)
{
    if (a > b)
        swap(a, b);
    auto dp = calc(a, b);
    if (dp[a][b] == 0)
        return 0;
    int ans = 0;
    for (int i = 0; i <= a; ++i)
    {
        for (int j = 0; j <= b; ++j)
        {
            int mi = min(a - i, b - j), ma = max(a - i, b - j);
            if (!dp[i][j] && mi * b != ma * a)
                ++ans;
        }
    }
    return ans;
}
int my(int a, int b)
{

    if (a > b)
        swap(a, b);
    int x = a / gcd(a, b), y = b / gcd(a, b);
    int ans = 0;
    for (int take_a = 0; take_a < a; ++take_a)
    {
        int takea = take_a;
        int na = a - takea;
        if (na * x % y == 0)
        {
            int nb = na * x / y;
            int takeb = b - nb;
            /// a < b
            /// na > nb // bruteforce
            /// -na < -nb
            /// a - na < b - nb
            /// takea < takeb so if min/max==x/y <=> takea == min, takeb == max;
            int g = gcd(takea, takeb);
            takea /= g;
            takeb /= g;
            if (takea != x || takeb != y)
                ++ans;
        }
    }
    return ans;
}

signed main()
{
    Start();
    /*
    mt19937 mt(123);
    while (true)
    {
        int a = mt() % 50 + 1, b = mt() % 50 + 1;
        cout << a << " : " << b << endl;
        int m = my(a, b), s = sol(a, b);
        if (m != s)
        {
            dbg(m), dbg(s);
            return 0;
        }
    }
    */
    int a, b;
    cin >> a >> b;
    cout << my(a, b);
    return 0;
}
