#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
//#define int ll
//#define double ld
//#define endl '\n'
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;
/*
const int MAX_MEM = 5e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new(size_t x)
{
    auto ret = MEM + CUR_MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete(void*){}
*/
template <class T>
istream& operator>> (istream &in, vector <T> &a) {for (auto &i : a) in >> i; return in;}
template <class T>
ostream& operator<< (ostream &out, vector <T> a) {for (auto &i : a) out << i << " "; return out;}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a) {in >> a.first >> a.second; return in;}
template <class T, class U>
ostream& operator<< (ostream &out, pair <T, U> a) {out << a.first << " " << a.second; return out;}

inline void Start()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}
using namespace __gnu_pbds;
using superset = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e9;
void relax(pll &a, pll b)
{
    if (a.first < b.first)
        a = b;
    else if (a.first == b.first && a.second > b.second)
        a = b;
}

pii my(int n, vector <int> h, vector <int> nh)
{
    pll best = {-INF, INF};
    vector <int> p(n);
    {
        iota(all(p), 0);
        sort(all(p), [&] (int i, int j) {return nh[i] > nh[j] || nh[i] == nh[j] && i < j;});
        int lst = 0;
        for (int i = 0; i < n; ++i)
        {
            if (nh[p[i]] != nh[p[lst]])
            {
                if (i - lst > 2)
                {
                    swap(p[i - 1], p[lst + 1]);
                }
                lst = i;
            }
        }
        if (n - lst >= 2)
            swap(p[n - 1], p[lst + 1]);
        ll ans = 0;
        int num = 0, l = INF, r = -INF, len = 0;
        int prer = r, prel = l;
        for (int i = 0; i < n; ++i)
        {
            ++len;
            if (i == 0)
            {
                prer = r, prel = l;
                l = min(l, p[i]);
                r = max(r, p[i]);
                num += int(nh[p[i]] != h[p[i]]);
                continue;
            }
            if (nh[p[i]] != nh[p[i - 1]])
                len = 1;
            if (r < p[i])
            {
                if (len == 2 && p[i - 1] == r && prer != -INF)
                    num -= int(nh[p[i - 1]] != h[p[i - 1]]);
                ans += ll(p[i] - r) * nh[p[i]];
                num += int(nh[p[i]] != h[p[i]]);
            }
            else if (p[i] < l)
            {
                ans += ll(l - p[i]) * nh[p[i]];
                num += int(nh[p[i]] != h[p[i]]);
            }
            prer = r, prel = l;
            l = min(l, p[i]);
            r = max(r, p[i]);
        }
        relax(best, mp(ans, num));
    }
    {
        iota(all(p), 0);
        sort(all(p), [&] (int i, int j) {return nh[i] > nh[j] || nh[i] == nh[j] && i < j;});
        int lst = 0;
        for (int i = 0; i < n; ++i)
        {
            if (nh[p[i]] != nh[p[lst]])
            {
                if (i - lst > 2)
                {
                    swap(p[i - 1], p[lst + 1]);
                }
                lst = i;
            }
        }
        if (n - lst >= 2)
            swap(p[n - 1], p[lst + 1]);
        nh[p[0]] = h[p[0]];
        iota(all(p), 0);
        sort(all(p), [&] (int i, int j) {return nh[i] > nh[j] || nh[i] == nh[j] && i < j;});
        lst = 0;
        for (int i = 0; i < n; ++i)
        {
            if (nh[p[i]] != nh[p[lst]])
            {
                if (i - lst > 2)
                {
                    swap(p[i - 1], p[lst + 1]);
                }
                lst = i;
            }
        }
        if (n - lst >= 2)
            swap(p[n - 1], p[lst + 1]);
        ll ans = 0;
        int num = 0, l = INF, r = -INF, len = 0;
        int prer = r, prel = l;
        for (int i = 0; i < n; ++i)
        {
            ++len;
            if (i == 0)
            {
                prer = r, prel = l;
                l = min(l, p[i]);
                r = max(r, p[i]);
                num += int(nh[p[i]] != h[p[i]]);
                continue;
            }
            if (nh[p[i]] != nh[p[i - 1]])
                len = 1;
            if (r < p[i])
            {
                if (len == 2 && p[i - 1] == r && prer != -INF)
                    num -= int(nh[p[i - 1]] != h[p[i - 1]]);
                ans += ll(p[i] - r) * nh[p[i]];
                num += int(nh[p[i]] != h[p[i]]);
            }
            else if (p[i] < l)
            {
                ans += ll(l - p[i]) * nh[p[i]];
                num += int(nh[p[i]] != h[p[i]]);
            }
            prer = r, prel = l;
            l = min(l, p[i]);
            r = max(r, p[i]);
        }
        relax(best, mp(ans, num));
    }
    return best;
}
signed main()
{
    Start();
    int n, k;
    cin >> n;
    vector <int> h(n);
    cin >> h;
    vector <int> nh = h;
    cin >> k;
    for (int i = 0; i < k; ++i)
    {
        int p, x;
        cin >> p >> x;
        nh[p] += x;
    }
    auto ans = my(n, h, nh);
    cout << ans.second << " " << ans.first;
    return 0;
}
