#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
#define int ll
//#define double ld
//#define endl '\n'
#define mp make_pair
#define pb emplace_back
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;
/*
const int MAX_MEM = 5e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new(size_t x)
{
    auto ret = MEM + CUR_MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete(void*){}
*/
template <class T>
istream& operator>> (istream &in, vector <T> &a) {for (auto &i : a) in >> i; return in;}
template <class T>
ostream& operator<< (ostream &out, vector <T> a) {for (auto &i : a) out << i << " "; return out;}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a) {in >> a.first >> a.second; return in;}
template <class T, class U>
ostream& operator<< (ostream &out, pair <T, U> a) {out << a.first << " " << a.second; return out;}

inline void Start()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}
using namespace __gnu_pbds;
using superset = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

signed main()
{
    Start();
    int n, k;
    cin >> n;
    vector <int> h(n);
    cin >> h;
    vector <int> nh = h;
    cin >> k;
    for (int i = 0; i < k; ++i)
    {
        int p, x;
        cin >> p >> x;
        nh[p] += x;
    }
    int maxi = *max_element(all(nh));
    int first = 0, last = 0;
    for (int i = 0; i < n; ++i)
    {
        if (maxi == nh[i])
        {
            first = i;
            break;
        }
    }
    for (int i = 0; i < n; ++i)
    {
        if (maxi == nh[i])
        {
            last = i;
        }
    }
    int num = 0, ans = (last - first) * maxi;
    num += int(nh[first] != h[first]) + int(nh[last] != h[last]);
    int was = 0;
    for (int i = 0; i < first; ++i)
    {
        int j = i;
        while (nh[i] >= nh[j])
            ++j;
        if (h[j] >= nh[i])
        {
            num += int(nh[i] != h[i] && !was);
            was = 0;
            ans += (j - i) * nh[i];
        }
        else
        {
            num += int(nh[i] != h[i] && !was) + int(nh[j] != h[j]);
            ans += (j - i) * nh[i];
            was = 1;
        }
    }
    was = 0;
    for (int i = n - 1; i > last; --i)
    {
        int j = i;
        while (nh[i] >= nh[j])
            --j;
        if (h[j] >= nh[i])
        {
            num += int(nh[i] != h[i] && !was);
            was = 0;
            ans += -(j - i) * nh[i];
        }
        else
        {
            num += int(nh[i] != h[i] && !was) + int(nh[j] != h[j]);
            ans += -(j - i) * nh[i];
            was = 1;
        }
    }
    cout << num << " " << ans;
    return 0;
}
