#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 5005;

int n, k;
int a[N][N];
ll pref[N][N];

ll get(int i1, int j1, int i2, int j2) {
    return pref[i2][j2] - pref[i2][j1 - 1] - pref[i1 - 1][j2] + pref[i1 - 1][j1 - 1];
}

bool check(int m) {
    for (int i = 1; i + m - 1 <= n; ++i) {
        for (int j = 1; j + m - 1 <= n; ++j) {
            if (get(i, j, i + m - 1, j + m - 1) < k) {
                return false;
            }
        }
    }
    return true;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> k;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            cin >> a[i][j];
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + a[i][j];
        }
    }
    int lef = 0, rig = n;
    while (lef + 1 < rig) {
        int mid = (lef + rig) / 2;
        if (check(mid)) rig = mid;
        else lef = mid;
    }
    if (!check(rig)) rig = -1;
    cout << rig << "\n";

    return 0;
}
