#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const ull INF = 1e18 + 31;
const ld EPS = 1.0e-8;

unordered_map<ull, bool> used, dp;

ull get_hash(int A, int B) {
	return (ull) A * INF + (ull) B;
}

bool are_equal(ld x, ld y) {
    return fabs(x - y) <= EPS;
}

bool calc(int A, int B) {
	ull curr = get_hash(A, B);
    if (used[curr]) return dp[curr];
    used[curr] = true;
    bool answ = false;
    for (int x = 0; x <= A; ++x) {
        for (int y = max(x, 1); y <= B; ++y) {
            if (!are_equal((ld) x / (ld) y, (ld) A / (ld) B) &&
                are_equal((ld) min(A - x, B - y) / (ld) max(A - x, B - y), (ld) A / (ld) B)) {
                answ |= !calc(min(A - x, B - y), max(A - x, B - y));
            }
        }
    }
    return dp[curr] = answ;
}

signed main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int A, B;
    cin >> A >> B;
    if (A > B) swap(A, B);
    calc(A, B);
    int ans = 0;
    for (int x = 0; x <= A; ++x) {
        for (int y = max(x, 1); y <= B; ++y) {
            if (!are_equal((ld) x / (ld) y, (ld) A / (ld) B) &&
                are_equal((ld) min(A - x, B - y) / (ld) max(A - x, B - y), (ld) A / (ld) B)) {
                ans += !dp[get_hash(min(A - x, B - y), max(A - x, B - y))];
            }
        }
    }
    cout << ans << "\n";

    return 0;
}
