#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define int long long
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const ull INF = 1e18 + 31;
const ld EPS = 1.0e-8;

gp_hash_table<ull, bool> used, dp;

ull get_hash(int A, int B) {
	return (ull) A * INF + (ull) B;
}

bool are_equal(ld x, ld y) {
    return fabs(x - y) <= EPS;
}

bool calc(int A, int B) {
	ull curr = get_hash(A, B);
    if (used[curr]) return dp[curr];
    used[curr] = true;
    bool answ = false;
    int g = __gcd(A, B), a = A / g, b = B / g, x = A % b, y = B - a * ((A - x) / b);
    while (x < A) {
		answ |= !calc(min(A - x, B - y), max(A - x, B - y));
		x += b, y += a;
	}
    return dp[curr] = answ;
}

vector<pii> get(int A, int B) {
	vector<pii> res;
	for (int x = 0; x <= A; ++x) {
        for (int y = max(x, 1ll); y <= B; ++y) {
            if (!are_equal((ld) x / (ld) y, (ld) A / (ld) B) &&
                are_equal((ld) min(A - x, B - y) / (ld) max(A - x, B - y), (ld) A / (ld) B)) {
                res.pb(mp(x, y));
            }
        }
    }
    return res;
}

signed main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);

	
	/*{
		int A, B;
		cin >> A >> B;
		auto need = get(A, B);
		int g = __gcd(A, B);
		cerr << A / g << " " << B / g << "\n";
		for (pii &p : need) {
			cerr << p.x << " " << p.y << "\n";
		}
	}*/
    int A, B;
    cin >> A >> B;
    if (A > B) swap(A, B);
    calc(A, B);
    int ans = 0;
    int g = __gcd(A, B), a = A / g, b = B / g, x = A % b, y = B - a * ((A - x) / b);
    while (x < A) {
		ans += !dp[get_hash(min(A - x, B - y), max(A - x, B - y))];
		x += b, y += a;
	}
    cout << ans << "\n";

    return 0;
}
