#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 1e6 + 5;

int n, k;
int a[N], b[N], use[N];
pii suf[N];

ll get_ans() {
	for (int i = n; i >= 1; --i) {
		suf[i] = max(suf[i + 1], mp(b[i], -i));
	}
    int i = 1;
    ll ans = 0;
    while (i < n) {
		if (suf[i + 1].x <= b[i]) {
			int idx = suf[i + 1].y;
            ans += 1ll * b[idx] * (idx - i);
            if (b[idx] > a[i]) use[i] = true;
			use[idx] = true;
            i = idx;
            continue;
		}
        int j = i + 1, idx = 0;
        while (j <= n) {
            if (b[j] > b[i]) {
                idx = j;
                break;
            }
            ++j;
        }
        assert(idx);
		ans += 1ll * b[i] * (idx - i);
        use[i] = true;
        if (b[i] > a[idx]) use[idx] = true;
		i = idx;
    }
    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        b[i] = a[i];
    }
    cin >> k;
    for (int i = 1; i <= k; ++i) {
        int x, y;
        cin >> x >> y;
        b[x + 1] += y;
    }
    int cnt = 0;
    ll ans = get_ans();
    for (int i = 1; i <= n; ++i) {
		if (a[i] != b[i] && use[i]) {
			cnt++;
		}
	}
    cout << cnt << " " << ans << "\n";

    return 0;
}
