#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define X first
#define Y second
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int readInt() {
    char c;
    c = getchar();
    int type = 1;
    int x = 0;
    if (c == '-') {
        type = -1;
        c = getchar();
    }
    while ('0' <= c && c <= '9') {
        x = (x * 10) + (c - '0');
        c = getchar();
    }
    return x * type;
}

int mas[30];

void writeInt(long long x, char c) {
    if (x == 0) {
        putchar('0');
        putchar(c);
        return;
    }
    if (x < 0) {
        putchar('-');
        x = abs(x);
    }
    int n = 0;
    while (x > 0) {
        mas[n] = x % 10;
        x /= 10;
        n++;
    }
    for (int i = n - 1; i >= 0; i--)
        putchar(mas[i] + '0');
    putchar(c);
    return;
}

int plu[1000010];
int a[1000010];
int b[1000010];

pair <int, int> mxsf[1000010];
pair <int, int> sl[1000010];
int sr[1000010];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    n = readInt();
    for (int i = 0; i < n; i++) {
        a[i] = readInt();
        b[i] = a[i];
    }
    k = readInt();
    int x, y;
    for (int i = 0; i < k; i++) {
        x = readInt();
        y = readInt();
        plu[x] = max(y, plu[x]);
        b[x] = a[x] + plu[x];
    }
    int mxpr = 0;
    int kk = 0;
    for (int i = n - 1; i >= 0; --i) {
        if (mxsf[i + 1].first < b[i]) {
            mxsf[i] = {b[i], i};
        } else {
            mxsf[i] = mxsf[i + 1];
        }
    }
    long long ans = 0, cnt2, su2, fsu2, fcnt2;
    long long tt1, tt2;
    for (long long i = 0; i < n; i++) {
        cnt2 = kk;
        su2 = mxpr;
        if (mxpr < b[i]) {
            mxpr = b[i];
            kk = i;
        }
        if (plu[i] == 0)
            continue;
        tt1 = 0, tt2 = 0;
        fsu2 = mxsf[i + 1].first;
        fcnt2 = mxsf[i + 1].second;
        if (su2 > b[i] && fsu2 > b[i]) {
            tt1 = ((long long)abs(fcnt2 - cnt2) * (long long)min(su2, fsu2));
        } else if (su2 > b[i]) {
            tt1 = ((long long)abs(i - cnt2) * (long long)b[i] + (long long)abs(i - fcnt2) * (long long)fsu2);
        } else if (fsu2 > b[i]) {
            tt1 = ((long long)abs(i - cnt2) * (long long)su2 + (long long)abs(i - fcnt2) * (long long)b[i]);
        } else {
            tt1 = ((long long)abs(i - cnt2) * (long long)su2 + (long long)abs(i - fcnt2) * (long long)fsu2);
        }
        if (su2 > a[i] && fsu2 > a[i]) {
            tt2 = ((long long)abs(fcnt2 - cnt2) * (long long)min(su2, fsu2));
        } else if (su2 > a[i]) {
            tt2 = ((long long)abs(i - cnt2) * (long long)a[i] + (long long)abs(i - fcnt2) * (long long)fsu2);
        } else if (fsu2 > a[i]) {
            tt2 = ((long long)abs(i - cnt2) * (long long)su2 + (long long)abs(i - fcnt2) * (long long)a[i]);
        } else {
            tt2 = ((long long)abs(i - cnt2) * (long long)su2 + (long long)abs(i - fcnt2) * (long long)fsu2);
        }
        if (tt1 > tt2) {
            ans++;
            a[i] = b[i];
        }
    }
    long long pans = 0;
    vector <int> v1;
    for (int i = 0; i < n; i++) {
        while (v1.size() > 0 && a[v1.back()] <= a[i]) {
            v1.pop_back();
        }
        if (v1.size() == 0) {
            sl[i] = {-1, -1};
        } else {
            sl[i] = {a[v1.back()], v1.back()};
        }
        v1.push_back(i);
    }
    v1.clear();
    for (int i = n - 1; i >= 0; --i) {
        while (v1.size() > 0 && a[v1.back()] <= a[i]) {
            v1.pop_back();
        }
        if (v1.size() == 0) {
            sr[i] = -1;
        }
        v1.push_back(i);
    }
    mxpr = 0;
    kk = 0;
    long long su1, cnt1;
    for (long long i = 0; i < n; i++) {
        su1 = -1, su2 = 0;
        cnt1 = 0, cnt2 = 0;
        bool f1 = false, f2 = false;
        if (sl[i].first != -1)
            f1 = true;
        if (sr[i] != -1)
            f2 = true;
        if (f1 == true && f2 == true)
            continue;
        if (sl[i].first != -1) {
            su1 = sl[i].first;
            cnt1 = sl[i].second;
        } else {
            cnt2 = kk;
            su2 = mxpr;
        }
        if (mxpr < a[i]) {
            mxpr = a[i];
            kk = i;
        }
        if (su1 != -1) {
            pans += ((long long)(i - cnt1) * (long long)a[i]);
        } else {
            pans += ((long long)(i - cnt2) * (long long)su2);
        }
    }
    writeInt(ans, ' ');
    writeInt(pans, '\n');
    return 0;
}

