#include <bits/stdc++.h>
using namespace std;

const int N = 1000005;

int a[N];
int b[N];
pair<int, int> inc[N];
int canInc[N];
int fbl[N];
int fbr[N];
bool shouldInc[N];
bool used[N];

int n, k;

inline void setLr();

int getMaxRain(){
    for(int i = 0; i < n; ++i){
        b[i] = a[i] + canInc[i];
        shouldInc[i] = (canInc[i] > 0);
        //cout << b[i] << " ";
    }
    setLr();

    int total = 0;
    for(int i = 0; i < n - 1;){
        if(fbr[i] == -1){
            total += b[i + 1];
            used[i + 1] = true;
            shouldInc[i] = shouldInc[i] && used[i];
            ++i;
        }else{
            total += b[i] * (fbr[i] - i); ///mene treba povecati, sve izmedju ne, poslednjeg ne znam
            int j = i + 1;
            while(j < fbr[i]){
                shouldInc[j] = false;
                j++;
            }
            if(a[j] < b[i])
                used[j] = true;
            i = fbr[i];
        }
    }

    return total;
}

int main()
{
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    cin >> k;
    for(int i = 0; i < k; ++i){
        cin >> inc[i].first >> inc[i].second;
        canInc[inc[i].first] = inc[i].second;
    }

    int mx = getMaxRain();
    int incs = 0;
    for(int i = 0; i < n; ++i){
        incs += (shouldInc[i] == 1);
    }
    cout << incs << " " << mx << "\n";
    return 0;
}
/*
6
2 4 2 4 2 1
2
2 1
4 1
----
1 14
*/


inline void setLr(){
    stack<pair<int, int>> st;
    for(int i = 0; i < n; ++i){
        while(!st.empty() && b[i] > st.top().first)
            st.pop();
        if(st.empty())
            fbl[i] = -1;
        else
            fbl[i] = st.top().second;
        st.push({b[i], i});
    }
    while(!st.empty())
        st.pop();
    for(int i = n - 1; i >= 0; --i){
        while(!st.empty() && b[i] > st.top().first)
            st.pop();
        if(st.empty())
            fbr[i] = -1;
        else
            fbr[i] = st.top().second;
        st.push({b[i], i});
    }

//    for(int i = 0; i < n; ++i){
//        cout << fbl[i] << " " << fbr[i] << "\n";
//    }
}
