#include <bits/stdc++.h>
using namespace std;

const long long N = 1000005;

long long a[N];
long long b[N];
pair<long long, long long> inc[N];
long long canInc[N];
pair<long long, long long> pl[N];
pair<long long, long long> pr[N];
bool shouldInc[N];
bool used[N];

long long n, k;

inline void setP();

long long getMaxRain(){
    for(long long i = 0; i < n; ++i){
        b[i] = a[i] + canInc[i];
        shouldInc[i] = (canInc[i] > 0);
        //cout << b[i] << " ";
    }
    setP();

    long long total = 0;
    for(long long i = 0; i < n - 1; ++i){
        total += min(pl[i].first, pr[i].first);

        if(i != pr[i - 1].second){
            shouldInc[i] = false;
        }
    }
    return total;
}

int main()
{
    cin >> n;
    for(long long i = 0; i < n; ++i){
        cin >> a[i];
    }
    cin >> k;
    for(long long i = 0; i < k; ++i){
        cin >> inc[i].first >> inc[i].second;
        canInc[inc[i].first] = inc[i].second;
    }

    long long mx = getMaxRain();
    long long incs = 0;
    for(long long i = 0; i < n; ++i)
        incs += (shouldInc[i] == 1);

    cout << incs << " " << mx << "\n";
    return 0;
}
/*
6
2 4 2 4 2 1
2
2 1
4 1
----
1 14

4
2 1 1 1
3
1 2
2 1
3 1
----
1 6
*/

inline void setP(){
    for(long long i = 0; i < n; ++i){
        if(i){
            if(b[i] > pl[i - 1].first){
                pl[i] = {b[i], i};
            }else{
                pl[i] = pl[i - 1];
            }
        }else{
            pl[i] = {b[i], i};
        }
    }
    for(long long i = n - 1; i >= 0; --i){
        if(i != n - 1){
            if(b[i + 1] > pr[i + 1].first){
                pr[i] = {b[i + 1], i + 1};
            }else{
                pr[i] = pr[i + 1];
            }
        }else{
            pr[i] = {-1, -1};
        }
    }

    for(long long i = 0; i < n; ++i){
        if(pr[pr[i].second].first != -1 && pr[pr[i].second].first == b[i]){
            pr[i] = pr[pr[i].second];
        }
    }

//    for(long long i = 0; i < n; ++i){
//        cout << pr[i].first << " " << pr[i].second << "\n";
//    }cout << "\n";
}
