#include <iostream>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstring>

#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ll long long
#define ss string
#define pb push_back

using namespace std;

const int N = 2005;

ll a, b, dp[N][N][5], a1, b1, ans;

int rec(int cur1, int cur2, int p){
    if(cur1 == 0 && cur2 == 0){
        if(p == 0)
            return 1;
        return 0;
    }
    if(dp[cur1][cur2][p]!= -1){
        return dp[cur1][cur2][p];
    }
    int ans = 0, pans = 0;
    for(int i = cur1; i >= 0; i--){
        for(int j = cur2; j >= 0;j--){
            int x = max(i, j), y = min(i, j);
            if(y == 0)
                continue;
            int x1 = x / __gcd(x, y);
            int y1 = y / __gcd(x, y);
            if(x1 != a1 || y1 != b1){
                int res = rec(cur1 - i, cur2 - j, 1 - p);
                if(res == 0){
                    continue;
                }
                ans += res;
   //             pans = ans;
            }
        }
    }
    return dp[cur1][cur2][p] = ans;
}

int main(){
    speed;
    memset(dp, -1, sizeof dp);
    cin >> a >> b;
    a1 = a / __gcd(a, b);
    b1 = b / __gcd(a, b);
    swap(a1, b1);
    for(int i = a; i >= 0; i--){
        for(int j = b; j >= 0; j--){
            int x = max(i, j), y = min(i, j);
            if(x == 0 && y == 0) continue;
            int x1 = 0;
            int y1 = 0;
            if(y != 0){
                x1 = x / __gcd(x, y);
                y1 = y / __gcd(y, x);
            }
            if(x1 != a1 || y1 != b1){
                x = max(a - i, b - j), y = min(a - i, b - j);
                if(y == 0)continue;
                x1 = x / __gcd(x, y);
                y1 = y / __gcd(y, x);
                if(x1 == a1 && y1 == b1){
                    ans++;
                }
            }
        }
    }
    cout << ans;
}
