#include <iostream>

using namespace std;

const int maxn = 5005;
int table[maxn][maxn];

long long row[maxn][maxn];

long long rectangle[maxn][maxn];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, k;
    cin >> n >> k;

    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            int k;
            cin >> k;
            table[i][j] = k;
        }
    }

    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            if(j==0){
                row[i][0] = table[i][0];
            }
            else{
                row[i][j] = row[i][j-1] + table[i][j];
            }
        }
    }

    for(int i=0; i<n; i++){
        for(int j=0; j<n; j++){
            if(i==0){
                rectangle[0][j] = row[0][j];
            }
            else{
                rectangle[i][j] = rectangle[i-1][j] + row[i][j];
            }
        }
    }

    bool solutionFound = false;
    int m = 1;
    for(m=1; m<n ;m++){
        bool noSolutionInThisCase = false;
        for(int i=0; i<=n-m; i++){
            for(int j=0; j<=n-m; j++){
                long long sum = rectangle[i+m-1][i+m-1];
                sum += rectangle[i-1][i-1];
                sum -= rectangle[i+m-1][i-1];
                sum -= rectangle[i-1][i+m-1];

                if(sum < k){
                    noSolutionInThisCase = true;
                    break;
                }
            }
            if(noSolutionInThisCase) break;
        }
        if(!noSolutionInThisCase){
            solutionFound = true;
            break;
        }
    }

    if(solutionFound){
        cout << m << endl;
    }
    else{
        cout << -1 << endl;
    }

    return 0;
}
