#include<iostream>
#include<algorithm>
using namespace std;

struct change{
int index;
int value;
bool operator <(change other)const{
    return index<other.index;
}
};

const int Max_N=1000010;
int n,k,cost=0,water=0;
int lengths [Max_N];
int maximum_left [Max_N];
int maximum_right [Max_N];
change cha [Max_N];

void init_max_left(){
    maximum_left[1]=0;
    if(n>2){
    for(int counter=2;counter<n;counter++){
        if(lengths[counter-1]>lengths[maximum_left[counter-1]]){
            maximum_left[counter]=counter-1;
        }else{
            maximum_left[counter]=maximum_left[counter-1];
        }
    }
    }
    return;
}

void init_max_right(){
    maximum_right[n-2]=n-1;
    if(n>2){
    for(int counter=n-3;counter>=0;counter--){
        if(lengths[counter+1]>=lengths[maximum_right[counter+1]]){
            maximum_right[counter]=counter+1;
        }else{
            maximum_right[counter]=maximum_right[counter+1];
        }
    }
    }
    maximum_right [n-1]=n-1;
    return;
}

int main(){
ios_base::sync_with_stdio(false);
cin>>n;
for(int counter=0;counter<n;counter++){
    cin>>lengths [counter];
}
cin>>k;
int a,b;
for(int counter=0;counter<k;counter++){
    cin>>a;
    cin>>b;
    cha[counter].index=a;
    cha[counter].value=b;
    lengths[a]+=b;
    cost+=b;
}
init_max_left();
init_max_right();
std::sort(cha,cha+k);
//for(int counter=0;counter<n;counter++){
//    cout<<maximum_left [counter]<<" ";
//}
//cout<<endl;
//for(int counter=0;counter<n;counter++){
//    cout<<maximum_right [counter]<<" ";
//}
int m_left_ind,m_left_val,m_right_ind,m_right_val,max_val;
for(int counter=0;counter<k;counter++){
    if(cha [counter].index==0){
        m_right_ind=maximum_right[0];
        m_right_val=lengths[m_right_ind];
        if(lengths[0]>m_right_val){
            if(lengths [0]-cha[counter].value>m_right_val){
                cost-=cha[counter].value;
                lengths [0]=lengths [0]-cha[counter].value;
            }else{
                cost-=(lengths[0]-m_right_val);
                lengths[0]=m_right_val;
            }
        }
    }else if(cha [counter].index==n-1){
        m_left_ind=maximum_left[n-1];
        m_left_val=lengths[m_left_ind];
        if(lengths[n-1]>m_left_val){
            if(lengths[n-1]-cha[counter].value>m_left_val){
                cost-=cha[counter].value;
                lengths [n-1]=lengths [n-1]-cha[counter].value;
            }else{
                cost-=(lengths[n-1]-m_left_val);
                lengths[n-1]=m_left_val;
            }
        }
    }else{
    m_right_ind=maximum_right[cha[counter].index];
    m_right_val=lengths[m_right_ind];
    m_left_ind=maximum_left[cha[counter].index];
    m_left_val=lengths[m_left_ind];
    max_val=max(m_left_val,m_right_val);
    if(m_left_val==m_right_val){
        cost-=cha[counter].value;
        lengths[cha[counter].index]-=cha[counter].value;
    }else{
        if(lengths[cha[counter].index]<=m_left_val and lengths[cha[counter].index]<=m_right_val){
            cost-=cha[counter].value;
            lengths[cha[counter].index]-=cha[counter].value;
        }
        if(lengths[cha[counter].index]>=m_left_val and lengths[cha[counter].index]>=m_right_val){
            if(lengths[cha[counter].index]-max_val>cha[counter].value){
                cost-=cha[counter].value;
                lengths[cha[counter].index]-=cha[counter].value;
            }else{
                cost-=lengths[cha[counter].index]-max_val;
                lengths[cha[counter].index]=max_val;
            }
        }
    }
    }
}
int m=0,c;
for(int counter=0;counter<n-1;counter){
    m=0;
    for(int cc=counter+1;cc<n;cc++){
        if(lengths[cc]>m){
            m=lengths[cc];
            c=cc;
        }
    }
    water+=min(lengths[m],lengths[c])*(c-counter);
    counter=c;
}
cout<<cost<<" "<<water+min(lengths[n-2],lengths[n-1]);
return 0;
}
