#include <bits/stdc++.h>
#define pb push_back
#define F first
#define S second
//#define endl '\n'

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = INT_MAX / 2;
const ll INFL = LLONG_MAX / 2;

/*
5 10
1 2 3 4 5
10 0 7 0 4
0 0 2 1 3
5 0 3 0 2
0 5 0 8 0
*/

int N, K;
ll field[5007][5007];
ll prefix[5007][5007];

bool check(int m) {
    for(int i = m - 1; i < N; i++) {
        for(int j = m - 1; j < N; j++) {
            ll sum = prefix[i][j];
            if (i >= m) sum -= prefix[i - m][j];
            if (j >= m) sum -= prefix[i][j - m];
            if (i >= m && j >= m) sum += prefix[i - m][j - m];
            if (sum < K) return 0;
        }
    }
    return 1;
}

int main() {
    cin >> N >> K;
    for(int i = 0; i < N; i++) {
        for(int j = 0; j < N; j++)
            cin >> field[i][j];
    }
    for(int i = 0; i < N; i++) {
        ll sum = 0;
        for(int j = 0; j < N; j++) {
            sum += field[i][j];
            prefix[i][j] = sum;
            if (i) prefix[i][j] += prefix[i - 1][j];
        }
    }
    int l = 1, r = N;
    while(l <= r) {
        int m = (l + r) / 2;
        if (check(m)) r = m - 1;
        else l = m + 1;
    }
    if (check(l)) cout << l << endl;
    else if (check(r)) cout << r << endl;
    else cout << -1 << endl;
    return 0;
}
