#include <bits/stdc++.h>
#define pb push_back
#define F first
#define S second
#define endl '\n'

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = INT_MAX / 2;
const ll INFL = LLONG_MAX / 2;

int t[5000007];

void build(int v, int vl, int vr, ll a[]) {
    if (vl == vr) {
        t[v] = a[vl];
        return;
    }
    int vm = vl + (vr - vl) / 2;
    build(v * 2 + 1, vl, vm, a);
    build(v * 2 + 2, vm + 1, vr, a);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int query(int v, int vl, int vr, int l, int r) {
    if (vl > vr || vr < l || vl > r) return 0;
    if (vl >= l && vr <= r) return t[v];
    int vm = vl + (vr - vl) / 2;
    int ql = query(v * 2 + 1, vl, vm, l, r);
    int qr = query(v * 2 + 2, vm + 1, vr, l, r);
    return max(ql, qr);
}

int N, K;
ll a[1000007];
ll c[1000007];
ll ext, vol;

/*
6
2 4 2 4 2 1
2
2 1
4 1

7
2 2 4 4 3 2 1
4
0 2
2 1
4 3
6 2

11
2 1 4 1 3 1 3 2 4 2 1
5
2 2
3 6
5 1
7 3
9 5
*/

int main() {
    ios_base::sync_with_stdio(0), cin.tie();
    cin >> N;
    for(int i = 0; i < N; i++)
        cin >> a[i], c[i] = a[i];
    cin >> K;
    vector<pii> q(K);
    for(int i = 0; i < K; i++) {
        cin >> q[i].F >> q[i].S;
        c[q[i].F] += q[i].S;
    }
    build(0, 0, N - 1, c);
    for(auto i : q) {
        ll lm, rm = lm = 0;
        if (i.F) lm = query(0, 0, N - 1, 0, i.F - 1);
        if (i.F != N - 1) rm = query(0, 0, N - 1, i.F + 1, N - 1);
        int to = min(a[i.F] + i.S, max(lm, rm));
        if (to > min(lm, rm)) ext++, a[i.F] = to;
    }
    //for(int i = 0; i < N; i++) cout << a[i] << " ";
    //cout << endl;
    int x = 0, mx = 0, pos = 0;
    for(int i = 0; i < N; i++) {
        if (a[i] >= mx) {
            mx = a[i];
            pos = i;
        }
    }
    for(int i = 0; i <= pos; i++) {
        if (a[i] >= a[x]) {
            vol += a[x] * (i - x);
            x = i;
            //cout << a[i] << " " << vol << endl;
        }
    }
    x = N - 1;
    for(int i = N - 1; i >= pos; i--) {
        if (a[i] >= a[x]) {
            vol += a[x] * (x - i);
            x = i;
            //cout << a[i] << " " << vol << endl;
        }
    }
    cout << ext << " " << vol << endl;
    return 0;
}
