#include<iostream>
using namespace std;

const int MAX_N = 5004;

int n, k, a;

int prefixrow[MAX_N][MAX_N];
int prefixcol[MAX_N][MAX_N];

int l, r;
int m, curr, copycurr;
int sumall;

bool ok;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k;

    for(int y = 1; y <= n; y++){
        for(int x = 1; x <= n; x++){
            cin >> a;
            sumall += a;
            prefixrow[y][x] = prefixrow[y][x-1] + a;
            prefixcol[y][x] = prefixcol[y-1][x] + a;
        }
    }

    if(sumall < k){
        cout << -1 << endl;
        return 0;
    }

    int cl = 1; ///curr length
    curr = prefixrow[1][1];

    for(int x = 1; x+cl <= n+1; x++){
        copycurr = curr;
        for(int y = 1; y+cl <= n+1; y++){
            if(copycurr < k){
                curr += prefixcol[cl][cl+1] + prefixrow[cl+1][cl+1];
                //cout << x << " " << y << " ";
                copycurr = copycurr + (prefixrow[y+cl][x+cl-1] - prefixrow[y+cl][x-1]) + (prefixcol[y+cl][x+cl] - prefixcol[y-1][x+cl]);
                //cout << prefixrow[y+cl][x+cl-1] - prefixrow[y+cl][x-1] << endl;
                y--;
                cl++;
            }else{
                copycurr = copycurr + (prefixrow[y+cl][x+cl-1] - prefixrow[y+cl][x-1]) - (prefixrow[y][x+cl-1] - prefixrow[y][x-1]);
            }
            //cout << cl << " " << copycurr << " " << y << endl;
        }
        curr = curr - prefixcol[cl][x] + prefixcol[cl][x+cl];
    }

    cout << cl << endl;

return 0;
}
/*
5 10
1 2 3 4 5
10 0 7 0 4
0 0 2 1 3
5 0 3 0 2
0 5 0 8 0
*/
