#include <iostream>
#include <stack>
#include <vector>

#define ull unsigned long long

const int MAXN = 1e6 + 10;

int arr[MAXN], l[MAXN], r[MAXN];
int arr2[MAXN], l2[MAXN], r2[MAXN];
std::stack<int> k;
std::vector<bool> is;

int main()
{
	std::cin.tie(NULL);
	std::cout.tie(NULL);
	std::ios_base::sync_with_stdio(false);

	ull ans = 0;

	int n;
	std::cin >> n;
	is.resize(n + 10);
	for(int i = 0; i < n; ++ i)
	{
		std::cin >> arr[i];
		arr2[i] = arr[i];
	}

	int sz = 1;
	k.push(0);

	for(int i = 1; i < n; ++ i)
	{
		while(k.size() > sz && arr[i] > arr[k.top()])
		{
			k.pop();
		}
		if(arr[i] > arr[k.top()])
		{
			++ sz;
		}
		l[i - 1] = k.top();
		k.push(i);
		//std::cout << l[i - 1] << ' ';
	}//std::cout << '\n';

	while(!k.empty())
	{
		k.pop();
	}
	k.push(n - 1);
	sz = 1;

	for(int i = n - 2; i >= 0; -- i)
	{
		while(k.size() > sz && arr[i] > arr[k.top()])
		{
			k.pop();
		}
		if(arr[i] > arr[k.top()])
		{
			++ sz;
		}
		r[i] = k.top();
		k.push(i);
		//std::cout << r[i] << ' ';
	}//std::cout << '\n';

	int K;
	std::cin >> K;

	for(int i = 0; i < K; ++ i)
	{
		int a, b;
		std::cin >> a >> b;
		arr2[a] += b;
	}

	while(!k.empty())
	{
		k.pop();
	}
	//k.push(n - 1);
	sz = 1;

	k.push(0);

	for(int i = 1; i < n; ++ i)
	{
		while(k.size() > sz && arr2[i] > arr2[k.top()])
		{
			k.pop();
		}
		if(arr2[i] > arr2[k.top()])
		{
			++ sz;
		}
		l2[i - 1] = k.top();
		k.push(i);
		//std::cout << l2[i - 1] << ' ';
	}//std::cout << '\n';

	while(!k.empty())
	{
		k.pop();
	}
	k.push(n - 1);
	sz = 1;

	for(int i = n - 2; i >= 0; -- i)
	{
		while(k.size() > sz && arr2[i] > arr2[k.top()])
		{
			k.pop();
		}
		if(arr2[i] > arr2[k.top()])
		{
			++ sz;
		}
		r2[i] = k.top();
		k.push(i);
		//std::cout << r2[i] << ' ';
	}//std::cout << '\n';

	for(int i = 0; i < n - 1; ++ i)
	{
		ans += (ull)(std::min((ull)arr2[l2[i]], (ull)arr2[r2[i]]));
		if(std::min(arr[l[i]], arr[r[i]]) == std::min(arr2[l2[i]], arr2[r2[i]]))
		{
			continue;
		}
		if(arr2[l2[i]] <= arr[r2[i]])
		{
			is[l2[i]] = true;
			continue;
		}
		if(arr2[r2[i]] <= arr[l2[i]])
		{
			is[r2[i]] = true;
			continue;
		}

		if(arr2[l2[i]] > arr[l2[i]])
		{
			is[l2[i]] = true;
		}
		if(arr2[r2[i]] > arr[r2[i]])
		{
			is[r2[i]] = true;
		}
	}

	int br = 0;

	for(int i = 0; i < n; ++ i)
	{
		br += is[i];
	}

	std::cout << br << ' ' << ans << '\n';

	return 0;
}