#include <iostream>
//#pragma gcc optimize ("O3")
#define endl '\n'
#define ull unsigned long long
using namespace std;
const int maxn = 5e3+200;
void cinout() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

ull grid[maxn][maxn];
ull prefix[maxn][maxn];

int main() {
    cinout();
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> grid[i][j];
            if (i==0 && j>0){
                prefix[i][j] = prefix[i][j-1] + grid[i][j];
            }
            if (j==0) {
                prefix[i][j] = prefix[i-1][j] + grid[i][j];
            }
            if (i==0 && j==0)
                prefix[0][0] = grid[0][0];
            if (i>0 && j>0) {
                prefix[i][j] = prefix[i-1][j]+prefix[i][j-1]-prefix[i-1][j-1]+ grid[i][j];
            }
        }
    }
    if (prefix[n-1][n-1]<k){
        int a=5,b=5;
        int c = 5/(a-b);
        return 0;
    }
    int left = 0, right = n;
    while(left+1 < right) {
        int m = left+right;
        m/=2;
        bool stanaLi = true;
        for (int i = 0; i < n-m && stanaLi; ++i) {
            for (int j = 0; j < n-m; ++j) {
                if(i==0 && j>0 && prefix[i+m-1][j+m-1]-prefix[i+m-1][j-1]<k){
                    stanaLi = false;
                    break;
                }
                if (j==0 && i>0 && prefix[i+m-1][j+m-1]-prefix[i-1][j+m-1]<k){
                    stanaLi = false;
                    break;
                }
                if (i==0 && j==0 && prefix[i+m-1][j+m-1] < k){
                    stanaLi = false;
                    break;
                }
                if (i>0 && j>0 && prefix[i+m-1][j+m-1]-prefix[i+m-1][j-1]-prefix[i-1][j+m-1]+prefix[i-1][j-1]<k){
                    stanaLi = false;
                    break;
                }
            }
        }
        if (stanaLi) {
            right = m;
        }else
            left = m;
    }
    cout << right << endl;
    return 0;
}
/*
5 10
1 2 3 4 5
10 0 7 0 4
0 5 2 5 3
5 0 3 0 2
0 5 0 8 0

*/
