#include <algorithm>
#include <iostream>
#define endl '\n'
using namespace std;

long long A, B;

long long rec(long long A1, long long B1, bool t)
{
    if (A1 > B1) swap(A1, B1);
    long long gcd = __gcd(A1, B1);
    if (gcd == 1 and !t) return 1;
    if (gcd == 1 and t) return 0;

    long long ans = 0;
    long long x, y;
    for (long long i = 1; i < gcd; ++ i)
    {
        x = A1 - i * A1 / gcd;
        y = B1 - i * B1 / gcd;
        if (x > y) swap(x, y);
        if (1ll * x * B1 != 1ll * A1 * y) ans += rec(i * A1 / gcd, i * B1 / gcd, !t);
        x = A1 - i * B1 / gcd;
        y = B1 - i * A1 / gcd;
        if (x > y) swap(x, y);
        if (!(x == 0 and y == 0) and x >= 0 and y >= 0 and 1ll * x * B1 != 1ll * A1 * y) ans += rec(i * B1 / gcd, i * A1 / gcd, !t);
    }

    if (!t)
    {
        if (ans == 0) return 1;
        return 0;
    }
    if (A1 == A and B1 == B) return ans;
    return (ans == 0 ? 0 : 1);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> A >> B;

    if (A == B)
    {
        cout << 0 << endl;
        return 0;
    }

    if (A > B) swap(A, B);

    cout << rec(A, B, true) << endl;

    return 0;
}
