#include <iostream>
#include <cstdio>
#define endl '\n'
using namespace std;

const int MAXN = 5000;

long long sum[MAXN + 5][MAXN + 5];

int main()
{
    int N;
    long long K;
    scanf("%d%lld", &N, &K);

    int num;
    for (int i = 1; i <= N; ++ i)
    {
        for (int j = 1; j <= N; ++ j)
        {
            scanf("%d", &num);
            sum[i][j] = sum[i - 1][j] + sum[i][j - 1] - sum[i - 1][j - 1] + num;
        }
    }

    bool t;
    long long s;
    for (int M = 1; M <= N; ++ M)
    {
        t = true;
        if (sum[M][M] < K) continue;
        for (int i = 1; i <= N - M + 1 and t; ++ i)
        {
            for (int j = 1; j <= N - M + 1 and t; ++ j)
            {
                s = sum[i + M - 1][j + M - 1] - sum[i - 1][j + M - 1] - sum[i + M - 1][j - 1] + sum[i - 1][j - 1];
                if (s < K) t = false;
            }
        }

        if (t)
        {
            printf("%d\n", M);
            return 0;
        }
    }

    printf("-1\n");

    return 0;
}
