#include <iostream>
#include <cstdio>
#define endl '\n'
using namespace std;

const int MAXN = 5000;

int N;
long long K;
long long sum[MAXN + 5][MAXN + 5];

bool check(int M)
{
    if (M == 0) return false;
    long long s;
    bool t = true;
    for (int i = 1; i <= N - M + 1 and t; ++ i)
    {
        for (int j = 1; j <= N - M + 1 and t; ++ j)
        {
            s = sum[i + M - 1][j + M - 1] - sum[i - 1][j + M - 1] - sum[i + M - 1][j - 1] + sum[i - 1][j - 1];
            if (s < K) t = false;
        }
    }

    return t;
}

int main()
{
    scanf("%d%lld", &N, &K);

    int num;
    for (int i = 1; i <= N; ++ i)
    {
        for (int j = 1; j <= N; ++ j)
        {
            scanf("%d", &num);
            sum[i][j] = sum[i - 1][j] + sum[i][j - 1] - sum[i - 1][j - 1] + num;
        }
    }

    if (!check(N))
    {
        printf("-1\n");
        return 0;
    }

    int l = 0, r = N, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (check(mid)) r = mid;
        else l = mid;
    }

    printf("%d\n", r);

    return 0;
}
