#include <iostream>
#include <stack>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;

int N, K;
int h[MAXN + 5];
int h1[MAXN + 5];
pair<int, int> ha[MAXN + 5];
int L[MAXN + 5], R[MAXN + 5];
int ans;
unsigned long long int area;

void rec(int cnt)
{
    unsigned long long int area1 = 0;
    stack<int> st;
    st.push(0);
    for (int i = 1; i <= N; ++ i)
    {
        while (h1[st.top()] < h1[i]) st.pop();
        L[i] = st.top();
        st.push(i);
    }

    while (!st.empty()) st.pop();

    st.push(N + 1);

    for (int i = N; i >= 1; -- i)
    {
        while (h1[st.top()] <= h1[i]) st.pop();
        R[i] = st.top();
        st.push(i);
    }

    int i = 1;
    while (R[i] != N + 1)
    {
        area1 += h1[i] * (R[i] - i);
        i = R[i];
    }

    int j = N;
    while (j != i)
    {
        area1 += h1[j] * (j - L[j]);
        j = L[j];
    }

    if (area1 != area) return;
    if (cnt < ans) ans = cnt;

    for (int i = 0; i < K; ++ i)
    {
        if (h[ha[i].first] + ha[i].second == h1[ha[i].first])
        {
            h1[ha[i].first] -= ha[i].second;
            rec(cnt - 1);
            h1[ha[i].first] += ha[i].second;
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> N;

    int fmax = 0, lmax = 0;
    for (int i = 1; i <= N; ++ i)
    {
        cin >> h[i];
        h1[i] = h[i];
        if (h[fmax] < h[i]) fmax = i;
        if (h[lmax] <= h[i]) lmax = i;
    }

    cin >> K;

    for (int i = 0; i < K; ++ i)
    {
        cin >> ha[i].first >> ha[i].second;
        ha[i].first++;
        h1[ha[i].first] += ha[i].second;
        if (h1[fmax] < h1[ha[i].first]) fmax = ha[i].first;
        if (h1[fmax] <= h1[ha[i].first] and fmax >= ha[i].first) fmax = ha[i].first;
        if (h1[lmax] <= h1[ha[i].first] and lmax <= ha[i].first) lmax = ha[i].first;
    }

    h1[0] = h1[N + 1] = 2 * MAXN + 5;
    stack<int> st;
    st.push(0);
    for (int i = 1; i <= N; ++ i)
    {
        while (h1[st.top()] < h1[i]) st.pop();
        L[i] = st.top();
        st.push(i);
    }

    while (!st.empty()) st.pop();

    st.push(N + 1);

    for (int i = N; i >= 1; -- i)
    {
        while (h1[st.top()] <= h1[i]) st.pop();
        R[i] = st.top();
        st.push(i);
    }

    int i = 1;
    while (R[i] != N + 1)
    {
        area += h1[i] * (R[i] - i);
        i = R[i];
    }

    int j = N;
    while (j != i)
    {
        area += h1[j] * (j - L[j]);
        j = L[j];
    }

    ans = K;

    for (int i = 0; i < K; ++ i)
    {
        if (h1[ha[i].first] < h1[fmax] and fmax < ha[i].first and ha[i].first < lmax)
        {
            ans--;
            h1[ha[i].first] -= ha[i].second;
        }
    }

    rec(ans);

    cout << ans << " " << area << endl;

    return 0;
}
