
///n^2?

#include <iostream>
using namespace std;

int a[5001][5001], lookup[5001][5001], n, k;

void init();
void build();
int sumQuery(int, int, int, int);
bool isValid(int);

int main()
{
    int lBound, rBound, curr=-1, lastCurr=-2;

    init();

    if (lookup[n][n]<k){
        cout<<"-1"<<endl;
        return 0;
    }

    lBound=1;
    rBound=n;
    while (curr!=lastCurr){
        lastCurr=curr;
        curr=(lBound+rBound)/2;
        if (isValid(curr)) rBound=curr;
        else lBound=curr;
    }
    if (!isValid(curr)) curr++;

    cout<<curr<<endl;
    /*for (int i=0; i<=n; i++){
        for (int j=0; j<=n; j++){
            cout<<lookup[i][j]<<" ";
        }
        cout<<endl;
    }*/

    return 0;
}
/**
5 10
1 2 3 4 5
10 0 7 0 4
0 0 2 1 3
5 0 3 0 2
0 5 0 8 0
----------------
4 22
1 2 3 4
5 6 7 8
9 10 11 12
13 14 15 16
*/

void init()
{
    cin>>n>>k;

    for (int i=1; i<=n; i++){
        for (int j=1; j<=n; j++){
            cin>>a[i][j];
        }
    }
    build();
}
void build()
{
    lookup[1][1]=a[1][1];
    for (int i=2; i<=n; i++){
        lookup[1][i]=lookup[1][i-1]+a[1][i];
        lookup[i][1]=lookup[i-1][1]+a[i][1];
    }
    for (int i=2; i<=n; i++){
        for (int j=2; j<=n; j++){
            lookup[i][j]=a[i][j]+lookup[i-1][j]+lookup[i][j-1]-lookup[i-1][j-1];
        }
    }
}
int sumQuery(int x1, int y1, int x2, int y2)
{
    return lookup[x2][y2]-lookup[x1-1][y2]-lookup[x2][y1-1]+lookup[x1-1][y1-1];
}
bool isValid(int m)
{
    int maxCoord=n-m+1;

    for (int i=1; i<=maxCoord; i++){
        for (int j=1; j<=maxCoord; j++){
            if (sumQuery(i, j, i+m-1, j+m-1)<k) return false;
        }
    }
    return true;
}
