#include<iostream>
#include<vector>
using namespace std;

struct Point
{
    int number;
    int height;
    int before, after;
};

vector<Point> highPoints;
vector<Point> allPosts;
int n, k;
int high[100000];

int main ()
{
    int answPosts = 0, answWater = 0;
    cin >> n;

    high[0] = 1;
    high[n-1] = 1;

    int a, b;
    cin >> a;

    //Set up first post
    Point newPoint;
    newPoint.height = a;
    newPoint.number = 0;
    newPoint.before = 0;
    allPosts.push_back(newPoint);

    // Take Input
    for(int i = 1; i < n; i++)
    {
        cin >> a;
        newPoint.height = a;
        newPoint.number = i;
        newPoint.before = allPosts.at(i-1).before;
        allPosts.push_back(newPoint);
    }

    //Set up last post
    allPosts.at(allPosts.size()-1).after = allPosts.size()-1;

    //Setting up highPoints
    int lastHighNum = 0;
    for(long i = 0; i < allPosts.size(); i++)
    {
        if(allPosts.at(i).height>=allPosts.at(lastHighNum).height)
        {
            lastHighNum = i;
            high[i] = 1;
        }
    }
    lastHighNum = n-1;
    for(long i = n-1; i > -1; i--)
    {
        if(allPosts.at(i).height>=allPosts.at(lastHighNum).height)
        {
            lastHighNum = i;
            high[i] = 1;
        }
    }
    lastHighNum = 0;
    for(int i = 1; i < n; i++)
    {
        if(high[i]==1)
        {
            highPoints.push_back(allPosts.at(i));
        }
    }

    //Setting up Before and After
    for(int i = 1; i < highPoints.size(); i++)
        highPoints.at(i).before = highPoints.at(i-1).number;
    for(int i = highPoints.size()-2; i > -1; i++)
        highPoints.at(i).after = highPoints.at(i+1).number;

    //Setting up first water amount
    for(long i = 1; i < highPoints.size(); i++)
        answWater += min(highPoints.at(i).height, highPoints.at(i-1).height) * (abs(highPoints.at(i).number - highPoints.at(i-1).number));

    //Calculation of adding fences and new water level
    cin >> k;
    for(int i = 0; i < k; i++)
    {
        cin >> a >> b;
        int MIN = min(highPoints.at(allPosts.at(a-1).before).height, highPoints.at(allPosts.at(a-1).after).height);

        if(allPosts.at(a-1).height + b <= MIN)
            allPosts.at(a-1).height += b;

        int MAX = max(highPoints.at(allPosts.at(a-1).before).height, highPoints.at(allPosts.at(a-1).after).height);
        answPosts += MAX - allPosts.at(a-1).height;
        int N2 = highPoints.at(allPosts.at(a-1).before).after;
        answWater += (MAX - allPosts.at(a-1).height)*(abs(a-N2-1));
    }

    cout << answPosts << " " << answWater << endl;

    return 0;
}
