#include <iostream>
using namespace std;
typedef long long lon;
#define endl '\n'
#define MAXN 5005
lon n, m;
lon dp[MAXN][MAXN];
bool check(lon att)
{
    for(lon i = att - 1; i < n; ++i){
        for(lon z = att - 1; z < n; ++z){
            lon sum = dp[i][z];
            if(i != att - 1) sum -= dp[i - att][z];
            if(z != att - 1) sum -= dp[i][z - att];
            if(i != att - 1 && z != att - 1) sum += dp[i - att][z - att];
            if(sum < m) return false;
        }
    }
    return true;
}
int main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> n >> m;
    for(lon i = 0; i < n; ++i){
        for(lon z = 0; z < n; ++z){
            lon input; cin >> input;
            if(i == 0 && z == 0) dp[i][z] = input;
            else if(i == 0) dp[i][z] = dp[i][z - 1] + input;
            else if(z == 0) dp[i][z] = dp[i - 1][z] + input;
            else dp[i][z] = dp[i - 1][z] + dp[i][z - 1] - dp[i - 1][z - 1] + input;
        }
    }
    lon left = 1, right = n, lastmid = -1;
    while(left <= right){
        lon mid = (left + right) / 2;
        if(check(mid)){
            lastmid = mid; right = mid - 1;
        }
        else left = mid + 1;
    }
    cout << lastmid << endl;
    return 0;
}
