#include <iostream>
#include <bitset>
using namespace std;
#define endl '\n'
#define MAXN int(1e6 + 5)
int br, offers, maximum, global, elim;
int arr[MAXN], height[MAXN];
bitset<MAXN> bs;
inline void update(int from, int to, int value)
{
    for(int i = from; i <= to; ++i){
        global -= height[i];
        height[i] = value;
        global += height[i];
        if(i != from){
            if(bs[i] == 1){
                ++elim; bs[i] = 0;
            }
        }
    }
}
inline void update2(int first, int value)
{
    //cout << "================\n";
    //cout << first << ' ' << value << endl;
    int i = first;
    for(; arr[first + 1] >= arr[i]; --i){
        global -= height[i];
        height[i] = value;
        global += height[i];
        if(bs[i] == 1){
            ++elim; bs[i] = 0;
        }
    }
    //cout << i << endl;
    global -= height[i];
    height[i] = value;
    global += height[i];
}
int main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> br;
    for(int i = 0; i < br; ++i){
        cin >> arr[i];
    }
    cin >> offers;
    for(int i = 0; i < offers; ++i){
        int index, value; cin >> index >> value;
        arr[index] += value; bs[index] = 1;
    }
    maximum = 0;
    for(int i = 1; i < br; ++i){
        if(arr[i] >= arr[maximum]){
            update(maximum, i - 1, arr[maximum]);
            if(arr[maximum] != arr[i]) maximum = i;
        }
        else{
            update2(i - 1, arr[i]);
        }
    }
    cout << offers - elim << ' ' << global << endl;
    return 0;
}
