#include <iostream>
#include <bitset>
using namespace std;
typedef long long lon;
#define endl '\n'
#define MAXN lon(1e6 + 5)
lon br, offers, maximum, global, elim, maxcount;
lon arr[MAXN], height[MAXN];
bitset<MAXN> bs;
bool update(lon from, lon to, lon value)
{
    bool something = false;
    for(lon i = from; i <= to; ++i){
        int copi = global, h = height[i];
        global -= height[i];
        height[i] = value;
        global += height[i];
        if(global > copi && h != 0) something = true;
        if(i != from){
            if(bs[i] == 1){
                ++elim; bs[i] = 0;
            }
        }
    }
    return something;
}
inline void update2(lon first, lon value)
{
    //cout << "================\n";
    //cout << first << ' ' << value << endl;
    lon i = first;
    for(; arr[first + 1] >= arr[i]; --i){
        global -= height[i];
        height[i] = value;
        global += height[i];
        if(bs[i] == 1){
            ++elim; bs[i] = 0;
        }
    }
    //cout << i << endl;
    global -= height[i];
    height[i] = value;
    global += height[i];
}
int main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> br;
    for(lon i = 0; i < br; ++i){
        cin >> arr[i];
    }
    cin >> offers;
    maximum = 0; maxcount = 1; bool someth = false;
    for(lon i = 0; i < offers; ++i){
        lon index, value; cin >> index >> value;
        arr[index] += value; bs[index] = 1;
    }
    for(lon i = 1; i < br; ++i){
        if(arr[i] >= arr[maximum]){
            bool b = update(maximum, i - 1, arr[maximum]);
            if(arr[maximum] != arr[i]){
                maximum = i; maxcount = 1; someth = b;
            }
            else ++maxcount;
        }
        else{
            update2(i - 1, arr[i]);
        }
    }
    if(maxcount == 1 && bs[maximum] == 1 && !someth) ++elim;
    cout << offers - elim << ' ' << global << endl;
    return 0;
}
