#include <iostream>

using namespace std;

int n, k, x;

int sp[5005][5005];

bool check(int lat) {
  for(int i = lat; i <= n; i++) {
    for(int j = lat; j <= n; j++) {
      if(sp[i][j] - sp[i][j - lat] - sp[i - lat][j] + sp[i - lat][j - lat] < k)
        return 0;
    }
  }
  return 1;
}

int main() {
  ios_base :: sync_with_stdio(false);
  cin.tie(0);
  cin >> n >> k;
  for(int i = 1; i <= n; i++) {
    for(int j = 1; j <= n; j++) {
      cin >> x;
      sp[i][j] = sp[i - 1][j] + sp[i][j - 1] - sp[i - 1][j - 1] + x;
    }
  }
  if(k > sp[n][n]) {
    cout << -1;
    return 0;
  }
  int st = 1, dr = n, mid;
  while(st <= dr) {
    mid = (st + dr) >> 1;
    if(check(mid))
      dr = mid - 1;
    else
      st = mid + 1;
  }
  cout << st;
  return 0;
}
