#include <iostream>
#include <algorithm>
#include <cstring>

using namespace std;

struct Number {
  int nr;
  int a[15];
  Number(int num) {
    nr = 0;
    memset(a, 0, sizeof(a));
    if(!num)
      nr = 1;
    while(num)
      a[++nr] = num % 10, num /= 10;
  }
  Number() {
    nr = 0;
    memset(a, 0, sizeof(a));
  }
  Number operator + (const Number &other) const {
    Number ans = Number();
    int t = 0, i;
    for(i = 1; i <= nr || i <= other.nr || t; i++, t /= 10) {
      t += a[i] + other.a[i];
      ans.a[i] = t % 10;
    }
    ans.nr = i - 1;
    return ans;
  }
};

long long x, y, z, A, B;
Number ans;

Number getAns(long long x, long long y, long long A, long long B) {
  if(x < B || y < A || x == 1 || y == 1)
    return (Number)1;
  return (Number)0;
}

int main() {
  cin >> x >> y;
  z = __gcd(x, y);
  if(z == 1 || x == y) {
    cout << 0;
    return 0;
  }
  A = x / z, B = y / z;
  for(int i = 1; (i <= B / A || i <= A / B) && i <= x / B && i <= y / A; i++)
    ans = ans + getAns(i * B, i * A, B, A);
  if(ans.nr == 0) {
    cout << 0;
    return 0;
  }
  for(int i = ans.nr; i >= 1; i--)
    cout << ans.a[i];
  return 0;
}
