#include <iostream>
#include <fstream>

using namespace std;

const int N = 1e6 + 7;

int h[N], stk[N];
int useful[N];
int a[N], b[N];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q, maxh(0);
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> h[i];
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        cin >> a[i] >> b[i];
        a[i]++;
        h[a[i]] += b[i];
    }
    for (int i = 1; i <= n; ++i)
        if (h[i] > h[maxh])
            maxh = i;
    int top(0);
    for (int i = maxh; i <= n; ++i) {
        while (top && ((h[stk[top]] < h[i]) || (h[stk[top]] == h[i] && top > 1)))
            --top;
        stk[++top] = i;
    }
    long long ans(0);
    for (int i = 1; i < top; ++i) {
        ans += 1LL * (stk[i + 1] - stk[i]) * h[stk[i + 1]];
        useful[stk[i]] = max(useful[stk[i]], h[stk[i + 1]]);///up to that point it is useful to raise it
        useful[stk[i + 1]] = max(useful[stk[i + 1]], h[stk[i + 1]]);
    }
    top = 0;
    for (int i = maxh; i >= 1; --i) {
        while (top && ((h[stk[top]] < h[i]) || (h[stk[top]] == h[i] && top > 1)))
            --top;
        stk[++top] = i;
    }
    for (int i = 1; i < top; ++i) {
        ans += 1LL * (stk[i] - stk[i + 1]) * h[stk[i + 1]];
        useful[stk[i]] = max(useful[stk[i]], h[stk[i + 1]]);
        useful[stk[i + 1]] = max(useful[stk[i + 1]], h[stk[i + 1]]);
    }
    int needed(0);
    for (int i = 1; i <= q; ++i)
        if (useful[a[i]] > h[a[i]] - b[i])
            ++needed;
    cout << needed << ' ' << ans;
    return 0;
}
