#include <iostream>

using namespace std;

using ll = long long;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 5000;
int v[1 + nmax][1 + nmax];
int sum[1 + nmax][1 + nmax];
int n,  k;

int getsum(int x, int y, int x2, int y2){
  return sum[x2][y2] - sum[x - 1][y2] - sum[x2][y - 1] + sum[x - 1][y - 1];
}

int test(int sz, int target){
  for(int i = 1;i <= n - sz + 1; i++)
    for(int j = 1;j <= n - sz + 1; j++)
      if(getsum(i, j, i + sz - 1, j + sz - 1) < target)
        return 0;
  return 1;
}

int binarysearch(int from, int to, int target){
  if(from < to){
    int mid = (from + to) / 2;
    if(test(mid, target) == 1)
      return binarysearch(from, mid, target);
    else
      return binarysearch(mid + 1, to, target);
  } else
    return from;
}
int main()
{
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  cin >> n >> k;
  for(int i = 1;i <= n; i++)
    for(int j = 1; j <= n; j++) {
       cin >> v[i][j];
       sum[i][j] = v[i][j] + sum[i][j - 1] + sum[i - 1][j] - sum[i - 1][j - 1];
    }
  int result = binarysearch(1, n + 1, k);
  if(n < result)
    cout << -1;
  else
    cout << result << '\n';
  return 0;
}
