#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) < (b)) ? (b) : (a))

int const nmax = 3000;
ld eps = 0.001;
ld a[1 + nmax], b[1 + nmax];

bool isvalid(int x, int y){
  ///x < y
  if(b[x] <= a[y]) {
    return 1;
    ld coef1 = a[y] - b[x];
    ld coef2 = b[y] - a[x];
    return !(-eps <= a[1] / b[1] * coef1 - coef2 && a[1] / b[1] * coef1 - coef2 <= eps);

    return a[1] / b[1] * coef1 != coef2;
  } else
    return 0;
}

int dp[1 + nmax];
int brut(int n, int m){
  if(m < n)
    swap(n, m);
  a[1] = n / __gcd(n, m);
  b[1] = m / __gcd(n, m);
  //cout << n << " " << m << '\n';
  int ptr = 1;
  while(a[ptr] <= n){
    ++ptr;
    a[ptr] = a[1] * ptr;
    b[ptr] = b[1] * ptr;
  }
  //cout << ptr << '\n';
  for(int i = 1;i < ptr; i++)
    dp[i] = 0;
  for(int i = 1;i < ptr; i++)
    for(int j = 1; j < i; j++)
      if(isvalid(j, i) == 1)
        dp[i] += (0 == dp[j]);

  //for(int i = 1;i < ptr; i++)
  //  cout << a[i] << " " << b[i] << " " << dp[i] << '\n';

  return dp[ptr - 1];
}

int smart(int n, int m){
  if(m < n)
    swap(n, m);
  a[1] = n / __gcd(n, m);
  b[1] = m / __gcd(n, m);

  int pos1 = ceil(b[1] / a[1]) - 1;
  int pos2 = floor(n / b[1]);
  return max(0, min(pos1, pos2));
}

int main()
{
  /*
  int n, m;
  cin >> n >> m;
  cout << brut(n, m) << '\n';
  */
  int n, m;
  cin >> n >> m;
  if(n == m)
    cout << 0;
  else
    cout << smart(n, m);
  /*
  for(int i = 1;i <= 100; i++)
    for(int j = 1;j <= 100; j++){
      if(brut(i, j) != smart(i, j)) {
        cout << i << " " << j << '\n';
        cout << brut(i, j) << " " << smart(i, j) << '\n';
        cout << '\n';
      }
    }
  /*
  a[1] = 3;
  b[1] = 7;
  for(int i = 2;i <= nmax; i++) {
    a[i] = a[1] * i;
    b[i] = b[1] * i;
  }
  for(int i = 1;i <= nmax; i++)
    cout << a[i] << " " << b[i] << '\n';

  for(int i = 1;i <= nmax; i++)
    for(int j = 1; j < i; j++) {
      if(a[j] <= b[i] && b[j] <= a[i]) {
        //cout << j << "->" << i << " " << isvalid(j, i) << '\n';
        if(isvalid(j, i) == 0) {
          cout << j << " " << i;
          cout << "ASDF";
          while(1);
        }
      }
    }
  */

  return 0;
}
