#include <iostream>

using namespace std;

const int N = 5000 + 7;
int n, k;
int sum[N][N];

int get(int r1, int c1, int r2, int c2)
{
    return sum[r2][c2] - sum[r1 - 1][c2] - sum[r2][c1 - 1] + sum[r1 - 1][c1 - 1];
}

bool ok(int len)
{
    for (int i = 1; i + len - 1 <= n; i++)
    {
        for (int j = 1; j + len - 1 <= n; j++)
        {
            if (get(i, j, i + len - 1, j + len - 1) < k)
            {
                return 0;
            }
        }
    }
    return 1;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

   // freopen ("input", "r", stdin);

    cin >> n >> k;
    for (int i = 1; i <= n; i++)
    {
        int cur = 0;
        for (int j = 1; j <= n; j++)
        {
            int x;
            cin >> x;
            cur += x;
            sum[i][j] = sum[i - 1][j] + cur;
        }
    }
    int l = 1, r = n, ans = -1;
    while (l <= r)
    {
        int mid = (l + r) / 2;
        if (ok(mid))
        {
            ans = mid;
            r = mid - 1;
        }
        else
        {
            l = mid + 1;
        }
    }
    cout << ans << "\n";
}

