#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const ll N = 1000000 + 7;
ll n;
ll q;
ll h[N];
ll inc[N];
ll use;
ll ans;
ll scad[N];
bool good[N];
pair<ll, ll> t[4 * N];

void build(ll v, ll tl, ll tr)
{
    if (tl == tr)
    {
        t[v] = {h[tl], tl};
    }
    else
    {
        ll tm = (tl + tr) / 2;
        build(2 * v, tl, tm);
        build(2 * v + 1, tm + 1, tr);
        t[v] = max(t[2 * v], t[2 * v + 1]);
    }
}

pair<ll, ll> get(ll v, ll tl, ll tr, ll l, ll r)
{
    if (tr < l || r < tl)
    {
        return {-1, -1};
    }
    if (l <= tl && tr <= r)
    {
        return t[v];
    }
    ll tm = (tl + tr) / 2;
    return min(get(2 * v, tl, tm, l, r), get(2 * v + 1, tm + 1, tr, l, r));
}

ll get(ll l, ll r)
{
    return get(1, 1, n, l, r).second;
}

ll suf_max[N];

void solve()
{
    for (ll i = n; i >= 1; i--)
    {
        suf_max[i] = max(suf_max[i + 1], h[i]);
    }
    ll l = 1;
    while (l <= n)
    {
        vector<ll> all;
        ll pm = 0;
        for (ll r = l; r <= n; r++)
        {
            pm = max(pm, h[r]);
            if (h[r] == pm)
            {
                all.push_back(r);
            }
        }
        ll last = all.back();
        if ((ll) all.size() >= 2)
        {
            ll mn = h[last] - inc[last];
            mn = max(mn, suf_max[last + 1]);
            mn = max(mn, h[all[(ll) all.size() - 2]]);
            use += mn - (h[last] - inc[last]);
        }
        else
        {
            use += inc[last];
        }
        for (ll i = 1; i < (ll) all.size(); i++)
        {
            ans += h[i] * (all[i] - all[i - 1]);
        }
        if (last != n)
        {
            ans += h[last + 1];
        }
        l = last + 1;
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

   // freopen ("input", "r", stdin);

    cin >> n;
    for (ll i = 1; i <= n; i++)
    {
        cin >> h[i];
    }
    cin >> q;
    while (q--)
    {
        ll i;
        ll x;
        cin >> i >> x;
        i++;
        inc[i] = x;
        h[i] += x;
    }
    build(1, 1, n);
    solve();
    cout << use << " " << ans << "\n";
}
