#include <iostream>

using namespace std;

int n, k;
int a[5005][5005];
int sp[5005][5005];

void Precalculare()
{
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            sp[i][j] = sp[i-1][j] + sp[i][j-1] - sp[i-1][j-1] + a[i][j];
}

int sum_patrat(int i, int j, int m)
{
    return sp[i][j] - sp[i-m][j] - sp[i][j-m] + sp[i-m][j-m];
}

bool verif (int m)
{
    for (int i = m; i <= n; ++i)
    {
        for (int j = m; j <= n; ++j)
            if (sum_patrat(i, j, m) < k) return false;
    }

    return true;
}

int main()
{
    cin >> n >> k;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            cin >> a[i][j];
        }
    }

    int step = 1;

    Precalculare();

    while (step < n) step <<= 1;
    int sol = 0;

    for (sol = 0; step; step>>=1)
    {
        if (sol + step <= n && verif(sol+step) == false)
            sol += step;
    }

    sol++;

    if (sol > n) cout << -1 << '\n';
    else cout << sol << '\n';
    return 0;
}
