#include <iostream>

using namespace std;

int n;
int k;
int a[5005][5005];
int sp[5005][5005];

int sum_patrat(int i, int j, int m)
{
    return sp[i][j] - sp[i-m][j] - sp[i][j-m] + sp[i-m][j-m];
}

int main()
{
    cin >> n >> k;

    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            cin >> a[i][j];

    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            sp[i][j] = sp[i-1][j] + sp[i][j-1] - sp[i-1][j-1] + a[i][j];

    if (sum_patrat(n, n, n) < k)
    {
        cout << -1 << '\n';
        return 0;
    }

    int sol = 1;
    int i = 0, j = 0;

    for (i = sol; i <= n; ++i)
    {
        for (j = sol; j <= n; ++j)
        {
            while (sol <= min(i, j) && sum_patrat(i, j, sol) < k) sol++;
        }
    }

    cout << sol << '\n';

    return 0;
}
