#include <iostream>
#include <deque>

using namespace std;

constexpr int NMAX = 1e6 + 5;
constexpr int INF = 1e9 + 5;

int n, k;
int lg[NMAX];

int cresc[NMAX];

deque <int> D;

int dr[NMAX];
int st[NMAX];

bool infl[NMAX];
int catecresc = 0;

int sol = 0;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++i)
        cin >> lg[i];

    lg[0] = INF;
    lg[n+1] = INF;

    cin >> k;

    for (int i = 1; i <= k; ++i)
    {
        int x, y;
        cin >> x >> y;

        x++;
        cresc[x] = y;
        lg[x] += y;
    }

    catecresc = k;

    int Max = 0;
    int poz = 0;

    for (int i = 1; i <= n; ++i)
    {
        st[i] = poz;
        if (lg[i] > Max)
        {
            Max = lg[i];
            poz = i;
        }
    }

    Max = 0;
    poz = n+1;

    for (int i = n; i >= 1; --i)
    {
        dr[i] = poz;
        if (lg[i] > Max)
        {
            Max = lg[i];
            poz = i;
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        infl[st[i]] = 1;
        infl[dr[i]] = 1;
    }

    for (int i = 2; i <= n; ++i)
    {
        if (cresc[i] > 0 && infl[i] == false)
        {
            catecresc--;
            lg[i] = lg[i] - cresc[i];
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        while (!D.empty() && lg[D.back()] < lg[i]) D.pop_back();

        D.push_back(i);
    }

    for (int i = 1; i < D.size(); ++i)
    {
        sol = sol + (D[i] - D[i-1]) * lg[D[i]];
    }

    for (int i = 1; i < D.front(); ++i)
        sol = sol + lg[i];

    cout << catecresc << " " << sol << '\n';
    return 0;
}
