#include <iostream>
#include <deque>

using namespace std;

constexpr int NMAX = 1e6 + 5;
constexpr int INF = 1e9 + 5;

int n, k;
int lg[NMAX];

int cresc[NMAX];

deque <int> D;
deque <int> inceput;

int dr[NMAX];
int st[NMAX];

bool infl[NMAX];

int sol = 0;
int nr_k = 0;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> lg[i];

    cin >> k;
    for (int i = 1; i <= k; ++i)
    {
        int x, y;
        cin >> x >> y;

        x++;
        cresc[x] = y;
        lg[x] += y;
    }

    for (int i = 1; i <= n; ++i)
    {
        while (!D.empty() && lg[D.back()] < lg[i])
            D.pop_back();

        D.push_back(i);
    }
    for (int i = 0; i < D.size(); ++i)
    {
        int x = D[i];
        if (cresc[x] > 0) nr_k++;
    }

    if (D.front() > 1)
    {
        inceput.push_back(1);
        for (int i = 2; i < D.front(); ++i)
        {
            int fir = inceput.front();
            while (!inceput.empty() && lg[inceput.back()] < lg[i])
            {
                inceput.pop_back();
            }

            if (inceput.empty())
            {
                sol = sol + lg[fir] * (i - fir);
                if (cresc[fir] > 0) nr_k++;
            }

            inceput.push_back(i);
        }

        sol = sol + lg[inceput.front()] * (D.front() - inceput.front());
        if  (cresc[inceput.front()] > 0) nr_k++;
    }

    for (int i = 1; i < D.size(); ++i)
        sol = sol + (D[i] - D[i-1]) * lg[D[i]];

    cout << nr_k << " " << sol << '\n';
    return 0;
}
