#include <iostream>
#include <deque>

using namespace std;

constexpr int NMAX = 1e6 + 5;
constexpr int INF = 1e9 + 5;

int n, k;
int lg[NMAX];

int cresc[NMAX];

deque <int> D;
deque <int> inceput;

long long sol = 0;
int nr_k = 0;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> lg[i];

    cin >> k;
    for (int i = 1; i <= k; ++i)
    {
        int x, y;
        cin >> x >> y;

        x++;
        cresc[x] = y;
        lg[x] += y;
    }

    D.push_back(1);

    for (int i = 2; i <= n; ++i)
    {
        int x = D.front();

        while (!D.empty() && lg[D.back()] < lg[i])
        {
            D.pop_back();
        }

        if (D.empty())
        {
            sol = sol + 1LL * lg[x] * (i - x);
            if (cresc[x] > 0) nr_k++;
        }

        D.push_back(i);
    }

    for (int i = 0; i < D.size(); ++i)
    {
        int x = D[i];
        if (cresc[x] > 0) nr_k++;
    }

    if (cresc[D[0]] > 0)
    {
        lg[D[0]] -= cresc[D[0]];
        int Max = 0;

        for (int i = 1; i <= n; ++i)
            Max = max(Max, lg[i]);

        if (Max == lg[D[0]]) nr_k--;
        else lg[D[0]] += cresc[D[0]];
    }

    for (int i = 1; i < D.size(); ++i)
    {
        int x = D[i];
        sol = sol + 1LL * lg[x] * (D[i] - D[i-1]);
    }

    cout << nr_k << " " << sol << '\n';
    return 0;
}
