#include <iostream>
#include <deque>

using namespace std;

constexpr int NMAX = 1e6 + 5;

int n, k;
long long lg[NMAX];

long long cresc[NMAX];

deque <int> D;

long long sol = 0;
int nr_k = 0;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> lg[i];

    cin >> k;
    for (int i = 1; i <= k; ++i)
    {
        int x, y;
        cin >> x >> y;

        x++;
        cresc[x] += y;
        lg[x] += y;
    }

    D.push_back(1);

    for (int i = 2; i <= n; ++i)
    {
        int aux = D.front();
        while (!D.empty() && lg[D.back()] < lg[i])
            D.pop_back();

        if (D.empty())
        {
            sol = sol + 1LL * lg[aux] * (i - aux);
            if (cresc[aux] > 0) nr_k++;
        }

        aux = 0;

        while (!D.empty() && lg[D.back()] == lg[i])
        {
            aux = D.back();
            D.pop_back();
        }

        if (D.empty() && aux > 0)
            D.push_back(aux);
        D.push_back(i);
    }

    for (int i = 0; i < D.size(); ++i)
        if (cresc[D[i]] > 0) nr_k++;

    if (cresc[D[0]] > 0)
    {
        long long Maxst = 0;
        long long Maxdr = 0;

        for (int i = 1; i < D[0]; ++i)
            Maxst = max(Maxst, lg[i]);
        for (int i = D[0]+1; i <= n; ++i)
            Maxdr = max(Maxdr, lg[i]);

        if (lg[D[0]] - cresc[D[0]] >= max(Maxst, Maxdr) || (lg[D[0]] - cresc[D[0]] <= Maxst && lg[D[0]] - cresc[D[0]] <= Maxdr)) nr_k--;
    }
    for (int i = 1; i < D.size(); ++i)
        sol = sol + 1LL * lg[D[i]] * (D[i] - D[i-1]);

    cout << nr_k << " " << sol << '\n';
    return 0;
}
