#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 5002;

int n, k;

int ma[N_MAX][N_MAX];

ll sp[N_MAX][N_MAX];

int c[N_MAX][N_MAX];

ll sum (int xa, int ya, int xb, int yb)
{
    xb = min(xb, n);
    yb = min(yb, n);
    return sp[xb][yb] - sp[xa - 1][yb] - sp[xb][ya - 1] + sp[xa - 1][ya - 1];
}

int mars[N_MAX];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
            cin >> ma[i][j];
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
            sp[i][j] = sp[i - 1][j] + sp[i][j - 1] - sp[i - 1][j - 1] + ma[i][j];
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
        {
            int l = 1, r = n + 1;
            while(l < r)
            {
                int mid = (l + r) / 2;
                if(sum(i, j, i + mid - 1, j + mid - 1) >= k)
                    r = mid;
                else
                    l = mid + 1;
            }
            c[i][j] = l;
        }
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
            mars[min(n - i + 1, n - j + 1)] = max(mars[min(n - i + 1, n - j + 1)], c[i][j]);
    for(int i = n; i >= 1; i--)
        mars[i] = max(mars[i], mars[i + 1]);
    for(int i = 1; i <= n; i++)
        if(mars[i] <= i)
        {
            cout << i << "\n";
            return 0;
        }
    cout << "-1\n";
    return 0;
}
