#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
ll n,m;
//#define LOCAL
ll psum[5001][5001];
ll get_sum(ll x,ll y,ll sz)
{
    ll ans=psum[x+sz][y+sz]-psum[x][y+sz]-psum[x+sz][y]+psum[x][y];
    return ans;
}
int main()
{
    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #endif // LOCAL
    cin>>n>>m;
    ll a[n][n];
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
            cin>>a[i][j];
    for(int i=0;i<=n;i++)
    {
        psum[0][i]=0;
        psum[i][0]=0;
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            psum[i][j]=psum[i-1][j]+psum[i][j-1]-psum[i-1][j-1]+a[i-1][j-1];
        }
    }
    if(psum[n][n]<m)
    {
        cout<<-1;
        return 0;
    }
    ll l=0,r=n;
    while(r-l>1)
    {
        ll mid=(l+r)/2;
        ll minans=1e18;
        for(int i=0;i<=n-mid;i++)
        {
            for(int j=0;j<=n-mid;j++)
            {
                minans=min(minans,get_sum(i,j,mid));
                //cout<<minans<<' '<<i<<' '<<j<<' '<<mid<<'\n';
            }
        }
        if(minans>=m)
            r=mid;
        else
            l=mid;
    }
    cout<<r;
    return 0;
}
