#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <numeric>


#define all(v) v.begin(), v.end()
#define ll long long
#define ld long double
#define trace(x) cout << " x : " << x << endl;


using namespace std;

const int inf = 1e9;
const int mod = 1e9 + 7;

#define int long long

map<pair<int, int>, int> mem;


int win(int a, int b) {
    if(mem.count({a, b}))
        return mem[{a, b}];
    int g = __gcd(a, b);
    if(g == 1) {
        return 0;
    }
    int p1 = a / g, p2 = b / g;
//    cerr << p1 << " " << p2 << endl;
    int ans = 0;
    for(int go = p2; go <= a && go / p2 * p1 <= b; go += p2) {
        if(win(go / p2 * p1, go) == 0)
            ans++;
    }
    mem[{a, b}] = ans;
    return ans;
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int a, b;
    cin >> a >> b;
    cout << win(a, b);
}
