#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <numeric>


#define all(v) v.begin(), v.end()
#define ll long long
#define ld long double
#define trace(x) cout << " x : " << x << endl;


using namespace std;

const int inf = 1e9;
const int mod = 1e9 + 7;

const int maxn = 1e6;

int h[maxn];
int a[maxn], ind[maxn];
int pref[maxn];
int suf[maxn];


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, k;
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> h[i];
//        cerr << "el" << h[i] << endl;
    }
    cin >>k;
    for(int i = 0; i < k; ++i){
        cin >> ind[i];
        cin >> a[i];
    }
    int mx = -1;
    int cnt = 0;
    for(int mask = 0; mask < (1 << k); ++mask){
        int cnt_now = 0;
        for(int i = 0; i < k; ++i) {
            if(((1 << i) & mask) != 0){
                h[ind[i]] += a[i];
                ++cnt_now;
            }
        }
        pref[0] = h[0];
        for(int i = 1; i < n; ++i){
            pref[i] = max(pref[i - 1], h[i]);
        }
        suf[n-1] = h[n-1];
        for(int i = n - 2; i >= 0; --i){
            suf[i] = max(suf[i + 1], h[i]);
        }
        int ans = 0;
//        cout << "debug mask: " << endl;
        for(int i = 0; i < n - 1; ++i) {
            ans += min(pref[i], suf[i + 1]);
//            cout << i << ": " << min(pref[i], suf[i + 1]) << " el " << h[i] << endl;
        }
        if(ans > mx) {
//            cerr <<"debug: " << mask << " " << ans << " " << cnt_now << endl;
            mx = ans;
            cnt = cnt_now;
//            cerr <<"debug: " << mx << " " << cnt << endl;
        }
        if(ans == mx){
            cnt = min(cnt_now, cnt);
        }
        for(int i = 0; i < k; ++i) {
            if(((1 << i) & mask) != 0){
                h[ind[i]] -= a[i];
            }
        }
    }
    cout << cnt << " " << mx;
}
