#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <numeric>


#define all(v) v.begin(), v.end()
#define ll long long
#define ld long double
#define trace(x) cout << " x : " << x << endl;


using namespace std;


const int inf = 1e9;
const int mod = 1e9 + 7;

const int maxn = 1e6;

int h[maxn];
int a[maxn];
int ind[maxn];
int suf[maxn];


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, k;
    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> h[i];
    }
    cin >> k;
//    assert(n * k < 1e8);
    for(int i = 0; i < k; ++i){
        cin >> ind[i];
        cin >> a[i];
        h[ind[i]] += a[i];
    }
    int cnt = k;
    suf[n-1] = h[n-1];
    for(int i = n - 2; i >= 0; --i) {
        suf[i] = max(suf[i + 1], h[i]);
    }
    ll mx = 0;
    int pref = 0;
    for(int i = 0; i < n - 1; ++i) {
        pref = max(pref, h[i]);
        mx += min(pref, suf[i + 1]);
    }
    for(int b = 0; b < k; ++b) {
        assert(0 <= ind[b] && ind[b] < n);
        h[ind[b]] -= a[b];
        pref = 0;
        suf[n-1] = h[n-1];
        for(int i = n - 2; i >= 0; --i){
            suf[i] = max(suf[i + 1], h[i]);
        }
        ll ans = 0;
        for(int i = 0; i < n - 1; ++i) {
            pref = max(h[i], pref);
            ans += min(pref, suf[i + 1]);
        }
        if(ans == mx){
            cnt--;
        }
        h[ind[b]] += a[b];
    }
    cout << cnt << " " << mx;
}
