#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <numeric>


#define all(v) v.begin(), v.end()
#define ll long long
#define ld long double
#define trace(x) cout << " x : " << x << endl;


using namespace std;


const int inf = 1e9;
const int mod = 1e9 + 7;

const int maxn = 1e6;

int h[maxn];
int a[maxn];
int ind[maxn];
int suf[maxn];
int pref[maxn];


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, k;
    cin >> n;
    for(int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    cin >> k;
    //    assert(n * k < 1e8);
    for(int i = 0; i < k; ++i) {
        cin >> ind[i];
        cin >> a[i];
        h[ind[i]] += a[i];
    }
    int cnt = 0;
    pref[0] = h[0];
    for(int i = 1; i < n; ++i){
        pref[i] = max(pref[i - 1], h[i]);
    }
    suf[n-1] = h[n-1];
    for(int i = n - 2; i >= 0; --i){
        suf[i] = max(suf[i + 1], h[i]);
    }
    ll mx = 0;
    for(int i = 0; i < n - 1; ++i) {
        mx += min(pref[i], suf[i + 1]);
    }
    for(int i = 0; i < k; ++i) {
        h[ind[i]] -= a[i];
    }
    for(int i = 0; i < k; ++i) {
        int j = ind[i];
        int left = 0;
        int right = 0;
        if(j != 0)
            left = pref[j - 1];
        if(j != n - 1)
            right = suf[j + 1];
        if(left != right && min(left, right) < h[j] + a[i])
            cnt++;
    }
    cout << cnt << " " << mx;
}
