#include<bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define pb push_back
#define mp make_pair

#define all(a) (a).begin(), (a).end()
#define sz(a) (int) (a).size()

#define ll long long
#define ld long double

const int N = 5e3;

int n, k, a[N][N], pr[N][N];

inline bool ok(int m) {
	for (int i = m - 1; i < n; i++) {
		for (int j = m - 1; j < n; j++) {
            int s = pr[i][j];
            if (i>=m) s -= pr[i - m][j];
            if (j>=m) s -= pr[i][j - m];
            if (i>=m && j>=m) s += pr[i - m][j-m];
            if (s<k) {
				return 0;
            }
		}
	}
	return 1;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
	cin >> n >> k;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> a[i][j];
		}
	}
	pr[0][0] = a[0][0];
	for (int i = 1; i < n; i++) {
		pr[i][0] = pr[i-1][0]+a[i][0];
	}
    for (int j = 1; j < n; j++) {
		pr[0][j] = pr[0][j-1]+a[0][j];
    }
    for (int i = 1; i < n; i++) {
		for (int j = 1; j < n; j++) {
			pr[i][j] = pr[i - 1][j] + pr[i][j-1] - pr[i - 1][j-1] + a[i][j];
		}
    }
    int lo = 0, hi = n+1;
    while (hi-lo > 1) {
        int mi = (lo+hi)/2;
        if (ok(mi)) {
            hi = mi;
        } else {
			lo = mi;
        }
    }
    cout << (hi == n+1 ? -1 : hi);
    return 0;
}
