//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,inline")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,popcnt,tune=native")
#include <bits/stdc++.h>
using namespace std;

//#define int long long
typedef long long ll;
typedef long double ldb;

const int MAXN = 5000 + 228;
int arr[MAXN][MAXN];
int mnNeed[MAXN][MAXN];

FILE *f;

char buf[4096];
int pos = 4096;

char getcc() {
	if (pos == 4096) {
		fread(buf, 1, 4096, f);
		pos = 0;
	}
	return buf[pos++];
}

int getInt() {
	int cur = 0;
	char c = getcc();
	while (!('0' <= c && c <= '9')) {
		c = getcc();
	}
	while ('0' <= c && c <= '9') {
		cur *= 10;
		cur += c - '0';
		c = getcc();
	}
	return cur;
}




signed main() {
	f = fopen("input.txt", "r");
	int n, k;
	n = getInt();
	k = getInt();
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			arr[i][j] = getInt();
		}
	}
	int sum = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			sum += arr[i][j];
		}
	}
	if (sum < k) {
		cout << -1 << endl;
		return 0;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			arr[i][j + 1] += arr[i][j];
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			arr[i + 1][j] += arr[i][j];
		}
	}
	auto get = [&](int i1, int j1, int i2, int j2) {
		return arr[i2][j2] - arr[i1][j2] - arr[i2][j1] + arr[i1][j1];
	};
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			mnNeed[i][j] = INT_MAX;
		}
	}
	for (int i = 0; i < n; i++) {
		int cur_ans = 1;
		for (int l = 0; l < n; l++) {
			while (l + cur_ans <= n && i + cur_ans <= n && get(i, l, i + cur_ans, l + cur_ans) < k) {
				int kek = get(i, l, i + cur_ans, l + cur_ans);;
				cur_ans++;
			}
			if (l + cur_ans <= n && i + cur_ans <= n && get(i, l, i + cur_ans, l + cur_ans) >= k) {
				mnNeed[i][l] = cur_ans;
			}
			cur_ans--;
		}
	}
	int m = n;
	int curMn = INT_MIN;
	for (m = n; m >= 1; m--) {
		for (int j = 0; j <= n - m; j++) {
			curMn = max(curMn, mnNeed[n - m][j]);
			curMn = max(curMn, mnNeed[j][n - m]);
		}
		if (curMn > m) {
			break;
		}
	}
	cout << m << endl;
	return 0;
}
