#include<bits/stdc++.h>

using namespace std;

vector<vector<int> > sp(5000, vector<int>(5000));
vector<vector<int> > dp(5001, vector<int>(5001));
int n, k;

bool func(int ch) {
    for (int i = ch; i <= n; ++i) {
        for (int j = ch; j <= n; ++j) {
            if (dp[i][j] - dp[i - ch][j] - dp[i][j - ch] + dp[i - ch][j - ch] < k) {
                return false;
            }
        }
    }
    return true;
}

void solve() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> sp[i][j];
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            dp[i][j] = dp[i - 1][j] + dp[i][j - 1] - dp[i - 1][j - 1] + sp[i - 1][j - 1];
        }
    }
    int l = 0;
    int r = n + 1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (func(m)) {
            r = m;
        }
        else {
            l = m;
        }
    }
    if (r == n + 1) {
        cout << -1 << endl;
    }
    else {
        cout << r << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int tests = 1;
    while (tests--) {
        solve();
    }
}
