#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 1e6 + 5;

int n, k;
int a[N], b[N], c[N], up[N];
pii suf[N];

ll get_ans() {
	for (int i = n; i >= 1; --i) {
		suf[i] = max(suf[i + 1], mp(c[i], i));
	}
    int i = 1;
    ll ans = 0;
    while (i < n) {
		if (suf[i + 1].x <= c[i]) {
			int idx = suf[i + 1].y;
            ans += 1ll * c[idx] * (idx - i);
			up[i] = true;
			up[idx] = true;
            i = idx;
            continue;
		}
        int j = i + 1, idx = 0;
        while (j <= n) {
            if (c[j] > c[i]) {
                idx = j;
                break;
            }
            ++j;
        }
		ans += 1ll * c[i] * (idx - i);
        up[i] = true;
        up[idx] = true;
		i = idx;
    }
    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        b[i] = a[i];
    }
    cin >> k;
    for (int i = 1; i <= k; ++i) {
        int x, y;
        cin >> x >> y;
        b[x + 1] += y;
    }
    for (int i = 1; i <= n; ++i) {
        c[i] = b[i];
    }
    int cnt = 0;
    ll ans = get_ans();
    /*for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            if (i == j) c[j] = a[j];
            else c[j] = b[j];
        }
        if (get_ans() < ans) {
            cnt++;
        }
    }*/
    for (int i = 1; i <= n; ++i) {
		if (a[i] != b[i] && up[i]) {
			cnt++;
		}
	}
    cout << cnt << " " << ans << "\n";

    return 0;
}
