#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("sse4")

#define int long long
#define x first
#define y second
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

//using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef std::pair<int, int> pii;

const ull INF = 1e18 + 31;

__gnu_pbds::gp_hash_table<int, bool> dp;

ull get_hash(int A, int B) {
	return (ull) A * INF + (ull) B;
}

int gcd(int a, int b) {
	while (b) {
		int tmp = a % b;
		a = b;
		b = tmp;
	}
	return a;
}

bool calc(int A, int B) {
	ull curr = get_hash(A, B);
    if (dp.find(curr) != dp.end()) return dp[curr];
    bool answ = false;
    int g = gcd(A, B), a = A / g, b = B / g, x = A % b, y = B - a * ((A - x) / b);
    while (x < A) {
		answ |= !calc(std::min(A - x, B - y), std::max(A - x, B - y));
		x += b, y += a;
	}
    return dp[curr] = answ;
}

signed main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // LOCAL
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);

    int A, B;
    std::cin >> A >> B;
    if (A > B) std::swap(A, B);
    calc(A, B);
    int ans = 0;
    int g = gcd(A, B), a = A / g, b = B / g, x = A % b, y = B - a * ((A - x) / b);
    while (x < A) {
		ans += !dp[get_hash(std::min(A - x, B - y), std::max(A - x, B - y))];
		x += b, y += a;
	}
    std::cout << ans << "\n";

    return 0;
}
