#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define X first
#define Y second
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int a[5004][5004];
int prefgor[5004][5004];
int prefvert[5004][5004];

int k, n;

bool sum(int m) {
    int su = 0;
    if (m == 0)
        return false;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            su += a[i][j];
        }
    }
    if (su < k)
        return false;
    for (int i = m - 1; i < n; i++) {
        if ((i - m + 1) % 2 == 0) {
            for (int j = m; j < n; j++) {
                su += prefvert[i + 1][j] - prefvert[i + 1 - m][j];
                su -= prefvert[i + 1][j - m] - prefvert[i + 1 - m][j - m];
                if (su < k)
                    return false;
            }
            if (i + 1 == n)
                break;
            su += prefgor[i + 1][n] - prefgor[i + 1][n - m];
            su -= prefgor[i + 1 - m][n] - prefgor[i + 1 - m][n - m];
            if (su < k)
                return false;
        } else {
            for (int j = n - m - 1; j >= 0; j--) {
                su += prefvert[i + 1][j] - prefvert[i + 1 - m][j];
                su -= prefvert[i + 1][j + m] - prefvert[i + 1 - m][j + m];
                if (su < k)
                    return false;
            }
            if (i + 1 == n)
                break;
            su += prefgor[i + 1][m];
            su -= prefgor[i + 1 - m][m];
            if (su < k)
                return false;
        }
    }
    return true;
}

int readInt() {
    char c;
    c = getchar();
    int type = 1;
    int x = 0;
    if (c == '-') {
        type = -1;
        c = getchar();
    }
    while ('0' <= c && c <= '9') {
        x = (x * 10) + (c - '0');
        c = getchar();
    }
    return x * type;
}

int mas[30];

void writeInt(int x) {
    if (x == 0) {
        putchar('0');
        putchar('\n');
        return;
    }
    if (x < 0) {
        putchar('-');
        x = abs(x);
    }
    int nn = 0;
    while (x > 0) {
        mas[nn] = x % 10;
        x /= 10;
        nn++;
    }
    for (int i = nn - 1; i >= 0; i--)
        putchar(mas[i] + '0');
    putchar('\n');
    return;
}

signed main() {
    //freopen("input.txt", "r", stdin);
    n = readInt();
    k = readInt();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            a[i][j] = readInt();
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= n; j++) {
            prefgor[i][j] = prefgor[i][j - 1] + a[i][j - 1];
        }
    }
    for (int j = 0; j < n; j++) {
        for (int i = 1; i <= n; i++) {
            prefvert[i][j] = prefvert[i - 1][j] + a[i - 1][j];
        }
    }
    int l = 0, r = n + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (!sum(mid)) {
            l = mid;
        } else {
            r = mid;
        }
    }
    if (!sum(r)) {
        writeInt(-1);
        return 0;
    }
    writeInt(r);
    return 0;
}

