#include <bits/stdc++.h>
using namespace std;

int mat[5005][5005];
int ps[5005][5005];
int n, k;

bool check(int mid){
    bool ok = true;
    for(int i = mid - 1; i < n; ++i){
        for(int j = mid - 1; j < n; ++j){
            int sum = ps[i][j] - (i - mid >= 0 ? ps[i - mid][j] : 0) - (j - mid >= 0 ? ps[i][j - mid] : 0) + (i - mid >= 0 && j - mid >= 0 ? ps[i - mid][j - mid] : 0);
            if(sum < k){
                ok = false;
                break;
            }
        }
    }

    return ok;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    cin >> n >> k;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < n; ++j){
            cin >> mat[i][j];
        }
    }

    for(int i = 0; i < n; ++i){
        for(int j = 0; j < n; ++j){
            ps[i][j] = mat[i][j] + (i > 0 ? ps[i - 1][j] : 0) + (j > 0 ? ps[i][j - 1] : 0) - (i > 0 && j > 0 ? ps[i - 1][j - 1] : 0);
        }
    }

    int l = 1, r = n;
    int mid;
    int lc = -1;
    while(l <= r){
        mid = (l + r) / 2;
        bool c = check(mid);
        if(c){
            lc = mid;
            r = mid - 1;
        }else{
            l = mid + 1;
        }
    }

    cout << lc << "\n";
    return 0;
}
