#include <bits/stdc++.h>
using namespace std;

const long long N =  1000005;

long long a[N];
long long b[N];
pair<long long, long long> inc[N];
long long canInc[N];
long long fbl[N];
long long fbr[N];
bool shouldInc[N];

long long n, k;

void setLr(long long*);
void setLr();

long long getMaxRain(){
    for(long long i = 0; i < n; ++i){
        b[i] = a[i] + canInc[i];
        shouldInc[i] = (canInc[i] > 0);
        //cout << b[i] << " ";
    }
    setLr(b);

    long long total = 0;
    for(long long i = 0; i < n - 1;){
        if(fbr[i] == -1){
            total += b[i + 1];
            shouldInc[i] = false || (fbr[i - 1] == -1); ///nisam siguran
            //cout << "1 " << b[i + 1] << "\n";
            ++i;
        }else{
            total += b[i] * (fbr[i] - i); ///mene treba povecati, sve izmedju ne, poslednjeg ne znam
            long long j = i + 1;
            while(j < fbr[i])
                shouldInc[j] = false, j++;
            //cout << "2 " << (fbr[i] - i) << "\n";
            i = fbr[i];
        }
    }

    return total;
}

int main()
{
    cin >> n;
    for(long long i = 0; i < n; ++i){
        cin >> a[i];
    }
    cin >> k;
    for(long long i = 0; i < k; ++i){
        cin >> inc[i].first >> inc[i].second;
        canInc[inc[i].first] = inc[i].second;
    }

    long long mx = getMaxRain();
    long long incs = 0;
    for(long long i = 0; i < n; ++i){
        incs += (shouldInc[i] == 1);
    }
    cout << incs << " " << mx << "\n";
    return 0;
}
/*
6
2 4 2 4 2 1
2
2 1
4 1
----
1 14
*/

void setLr(long long* niz){
    stack<pair<long long, long long>> st;
    for(long long i = 0; i < n; ++i){
        while(!st.empty() && niz[i] > st.top().first)
            st.pop();
        if(st.empty())
            fbl[i] = -1;
        else
            fbl[i] = st.top().second;
        st.push({niz[i], i});
    }
    while(!st.empty())
        st.pop();
    for(long long i = n - 1; i >= 0; --i){
        while(!st.empty() && niz[i] > st.top().first)
            st.pop();
        if(st.empty())
            fbr[i] = -1;
        else
            fbr[i] = st.top().second;
        st.push({niz[i], i});
    }

//    for(long long i = 0; i < n; ++i){
//        cout << fbl[i] << " " << fbr[i] << "\n";
//    }
}

void setLr(){
    stack<pair<long long, long long>> st;
    for(long long i = 0; i < n; ++i){
        while(!st.empty() && b[i] > st.top().first)
            st.pop();
        if(st.empty())
            fbl[i] = -1;
        else
            fbl[i] = st.top().second;
        st.push({b[i], i});
    }
    while(!st.empty())
        st.pop();
    for(long long i = n - 1; i >= 0; --i){
        while(!st.empty() && b[i] > st.top().first)
            st.pop();
        if(st.empty())
            fbr[i] = -1;
        else
            fbr[i] = st.top().second;
        st.push({b[i], i});
    }

//    for(long long i = 0; i < n; ++i){
//        cout << fbl[i] << " " << fbr[i] << "\n";
//    }
}
