#include <bits/stdc++.h>
using namespace std;

const long long N = 1000005;

long long a[N];
long long b[N];
pair<long long, long long> inc[N];
long long canInc[N];
long long fbl[N];
long long fbr[N];

long long n, k;

inline void setLr();

inline long long getRain(){
    setLr();

    long long total = 0;
    for(long long i = 0; i < n - 1;){
        if(fbr[i] == -1){
            total += b[i + 1];
            ++i;
        }else{
            total += 1LL * b[i] * (fbr[i] - i); //mene treba povecati, sve izmedju ne, poslednjeg ne znam
            i = fbr[i];
        }
    }

    return total;
}

int main()
{
    cin >> n;
    for(long long i = 0; i < n; ++i){
        cin >> a[i];
    }
    cin >> k;
    for(long long i = 0; i < k; ++i){
        cin >> inc[i].first >> inc[i].second;
        canInc[inc[i].first] = inc[i].second;
    }

    for(long long i = 0; i < n; ++i)
        b[i] = a[i] + canInc[i];
    long long mx = getRain();

    long long mnincs = k;
    for(long long i = 0; i < n; ++i){
        b[i] = a[i];
    }
    for(long long mask = 0; mask < (1 << k); ++mask){
        long long nm = 0;
        for(long long j = 0; j < k; ++j){
            if(mask & (1 << j)){
                b[inc[j].first] = a[inc[j].first] + inc[j].second;
                nm++;
            }
        }

        long long curr = (nm >= mnincs ? -1 : getRain());
        if(curr == mx)
            mnincs = min(mnincs, nm);

        for(long long j = 0; j < k; ++j){
            if(mask & (1 << j)){
                b[inc[j].first] = a[inc[j].first];
            }
        }
    }

    cout << mnincs << " " << mx << "\n";
    return 0;
}
/*
6
2 4 2 4 2 1
2
2 1
4 1
----
1 14
*/


inline void setLr(){
    stack<pair<long long, long long>> st;
    for(long long i = 0; i < n; ++i){
        while(!st.empty() && b[i] > st.top().first)
            st.pop();
        if(st.empty())
            fbl[i] = -1;
        else
            fbl[i] = st.top().second;
        st.push({b[i], i});
    }
    while(!st.empty())
        st.pop();
    for(long long i = n - 1; i >= 0; --i){
        while(!st.empty() && b[i] > st.top().first)
            st.pop();
        if(st.empty())
            fbr[i] = -1;
        else
            fbr[i] = st.top().second;
        st.push({b[i], i});
    }

//    for(long long i = 0; i < n; ++i){
//        cout << fbl[i] << " " << fbr[i] << "\n";
//    }
}
