#include <bits/stdc++.h>
using namespace std;

const long long N = 1000005;

long long a[N];
long long b[N];
pair<long long, long long> inc[N];
long long canInc[N];
long long fbl[N];
long long fbr[N];
long long pl[N];
long long pr[N];

long long n, k;

inline void setLr();
inline void setP();

inline long long getRain(){
    setLr();
    setP();

    long long total = 0;
    deque<pair<int, int>> dq;
    for(long long i = 0; i < n; ++i){
        while(!dq.empty() && dq.back().first <= b[i]){
            total += dq.back().first;
            dq.pop_back();
        }
        dq.push_back({b[i], i});
    }
    while(!dq.empty()){
        //cout << dq.back().second << "\n";
        if(dq.back().second == n - 1){
            dq.pop_back();
            continue;
        }
        total += pr[dq.back().second];
        dq.pop_back();
    }

    return total;
}

int main()
{
    cin >> n;
    for(long long i = 0; i < n; ++i){
        cin >> a[i];
    }
    cin >> k;
    for(long long i = 0; i < k; ++i){
        cin >> inc[i].first >> inc[i].second;
        canInc[inc[i].first] = inc[i].second;
    }

    for(long long i = 0; i < n; ++i)
        b[i] = a[i] + canInc[i];
    long long mx = getRain();

    long long mnincs = k;
    for(long long i = 0; i < n; ++i){
        b[i] = a[i];
    }
    for(long long mask = 0; mask < (1 << k); ++mask){
        long long nm = 0;
        for(long long j = 0; j < k; ++j){
            if(mask & (1 << j)){
                b[inc[j].first] = a[inc[j].first] + inc[j].second;
                nm++;
            }
        }

        long long curr = (nm >= mnincs ? -1 : getRain());
        if(curr >= mx)
            mnincs = min(mnincs, nm);

        for(long long j = 0; j < k; ++j){
            if(mask & (1 << j)){
                b[inc[j].first] = a[inc[j].first];
            }
        }
    }

    cout << mnincs << " " << mx << "\n";
    return 0;
}
/*
6
2 4 2 4 2 1
2
2 1
4 1
----
1 14


4
2 1 1 1
3
1 2
2 1
3 1
----
1 6
*/

void setP(){
    for(long long i = 0; i < n; ++i){
        if(i){
            pl[i] = max(pl[i - 1], b[i]);
        }else{
            pl[i] = b[i];
        }
    }
    for(long long i = n - 1; i >= 0; --i){
        if(i != n - 1){
            pr[i] = max(pr[i + 1], b[i + 1]);
        }else{
            pr[i] = 0;
        }
    }

//    for(long long i = 0; i < n; ++i){
//        cout << pl[i] << " " << pr[i];
//    }cout << "\n";
}


inline void setLr(){
    stack<pair<long long, long long>> st;
    for(long long i = 0; i < n; ++i){
        while(!st.empty() && b[i] > st.top().first)
            st.pop();
        if(st.empty())
            fbl[i] = -1;
        else
            fbl[i] = st.top().second;
        st.push({b[i], i});
    }
    while(!st.empty())
        st.pop();
    for(long long i = n - 1; i >= 0; --i){
        while(!st.empty() && b[i] > st.top().first)
            st.pop();
        if(st.empty())
            fbr[i] = -1;
        else
            fbr[i] = st.top().second;
        st.push({b[i], i});
    }

//    for(long long i = 0; i < n; ++i){
//        cout << fbl[i] << " " << fbr[i] << "\n";
//    }
}
