#include <iostream>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstring>

#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ll long long
#define ss string
#define pb push_back

using namespace std;

const int N = int(5e3) + 5;

int n, a[N][N], s[N][N], k;

int su(int x, int y, int l){
    int res = 0;
    for(int i = x; i <= x + l - 1; i++){
        res += s[i][y + l - 1] - s[i][y - 1];
    }
    return res;
}

int stu(int x, int y, int l){
    int res = 0;
    for(int i = x; i <= x + l - 1; i++){
        for(int j = y; j <= l - 1 + y; j++){
            res += a[i][j];
        }
    }
    return res;
}

int main(){
    speed;
    cin >> n>> k;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            cin >> a[i][j];
        }
    }
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            s[i][j] = s[i][j - 1] + a[i][j];
        }
    }
    for(int m = 1; m <= n; m++){
        bool cond = 0;
        for(int i = 1; i + m - 1 <= n; i++){
            for(int j = 1; j + m - 1 <= n; j++){
               // if(n <= 100){
                if(su(i, j, m) < k){
                    cond = 1;
                    break;
                }
            }
            if(cond) break;
        }
        if(!cond){
            cout << m;
            return 0;
        }
    }
    cout << -1;
}
