#include <iostream>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstring>

#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ll long long
#define ss string
#define pb push_back

using namespace std;

const int N = int(5e3) + 5;

int n, a[N][N], s[N][N], k;

int su(int i, int j, int l){
    int res = 0;
    res = s[i + l - 1][j + l - 1] - (s[i - 1][j + l - 1] + s[i + l - 1][j - 1] - s[i - 1][j - 1]);
    return res;
}

int stu(int x, int y, int l){
    int res = 0;
    for(int i = x; i <= x + l - 1; i++){
        for(int j = y; j <= l - 1 + y; j++){
            res += a[i][j];
        }
    }
    return res;
}

int main(){
    speed;
    cin >> n>> k;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            cin >> a[i][j];
        }
    }
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            s[i][j] = s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1] + a[i][j];
        }
    }
    int l = 0, r = n + 1;
    while(r - l > 1){
        bool cond = 0;
        int m = (r + l) / 2;
        for(int i = 1; i + m - 1 <= n; i++){
            for(int j = 1; j + m - 1 <= n; j++){
               // if(n <= 100){
                if(su(i, j, m) < k){
                    cond = 1;
                    break;
                }
            }
            if(cond) break;
        }
        if(!cond){
            r = m;
        }
        else{
            l = m;
        }
    }
    bool cond = 0;
    int m = r;
    for(int i = 1; i + m - 1 <= n; i++){
        for(int j = 1; j + m - 1 <= n; j++){
           // if(n <= 100){
            if(su(i, j, m) < k){
                cond = 1;
                break;
            }
        }
        if(cond) break;
    }
    if(!cond){
        cout << r;
    }
    else
        cout << -1;
}
