#include <iostream>
#include <vector>
using namespace std;

signed main()
{
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();
    int n,k;
    cin >> n >> k;
    vector <vector <int> > a(n+1);
    for (int i=1; i<=n; i++){
        a[i].push_back(0);
        for (int j=1; j<=n; j++){
            int x;
            cin >> x;
            a[i].push_back(x);
        }
    }
    vector <vector <int> > s(n+1, vector <int> (n+1,0));
    for (int i=1; i<=n; i++){
        for (int j=1; j<=n; j++){
            s[i][j]=s[i-1][j]+s[i][j-1]-s[i-1][j-1]+a[i][j];
        }
    }
    int l=0, r=n+1;
    int m=n;
    bool log=true;

    while (l+1<r){
        m=(l+r)>>1;
        log=true;
        for (int i=1; i<n-m+2; i++){
            if (!log)break;
            for (int j=1; j<n-m+2; j++){
                if (s[i+m-1][j+m-1]+s[i-1][j-1]-s[i-1][j+m-1]-s[i+m-1][j-1]<k){
                    log=false;
                    break;
                }
            }
        }
        if (log) r=m;
        else l=m;
    }
    if (r==n+1){
        cout << -1;
        return 0;
    }
    cout << r;
}
/*
5 10
1 2 3 4 5
10 0 7 0 4
0 0 2 1 3
5 0 3 0 2
0 5 0 8 0
*/



