#include<iostream>
#include<cmath>

using namespace  std;

const int MAXN = 5000;

int n,k,m;
int pole[MAXN+1][MAXN+1];
int dp[MAXN+1][MAXN+1];

int main()
{
    cin >> n >>k;
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
        {
            cin >> pole[i][j];
        }

    for(int i=0;i<n;i++) dp[i][0] = pole[i][0];
    for(int i=0;i<n;i++) dp[0][i] = pole[0][i];

    for(int i=1;i<n;i++)
        for(int j=0;j<n;j++)
        {
            dp[i][j] = dp[i-1][j]+ pole[i][j];
        }

    bool flag = false;
    for(int m=1;m<=n;m++)
    {
        flag =false;
        for(int i=0;i<=n-m;i++)
            {
                for(int j=0;j<=n-m;j++)
                {
                    int sumBig=0;
                    for(int d=j;d<j+m;d++) sumBig += dp[i+m-1][d];
                    int sumSmall=0;
                    if(i!=0) for(int d=j;d<j+m;d++) sumSmall += dp[i-1][d];
                    //cout << i << ' ' << j << ' ' << m << ' ' << sumBig - sumSmall << '\n';
                    if(sumBig - sumSmall <= k) flag = true;
                }
                if(flag == true) break;
            }
            if(flag == false) {cout << m << '\n'; return 0;}
    }
    return 0;
}
/**


5 10
1 2 3 4 5
10 0 7 0 4
0 0 2 1 3
5 0 3 0 2
0 5 0 8 0




1 1 2 12

1 2_3_4 5
11|2 10|4 9
11|2_12|5 12
16 2 15 5 14
16 7 15 13 14
**/


