#include <iostream>

using namespace std;

long long GCD(int a, int b){
    long long rem = a%b;
    if(rem == 0) return b;
    return GCD(b, rem);
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    long long a, b;
    cin >> a >> b;

    if (b > a){
        long long note = a;
        a = b;
        b = note;
    }

    if(a == b) cout << 0 << endl;

    long long gcd = GCD(a, b);

    long long a1 = a / gcd;
    long long b1 = b / gcd;    /// (a1, b1) = 1   and   alpha = a1/b1

    long long x, y;    /// we take x from a   and   y from b

    long long countt = 0;

    for(x = 0; x<a; x++){
        if( (x - a) % b1 != 0 ) continue;   /// first see the next comment      y has to be a whole number
        y = b + ((x-a)/b1)*a1;   /// according to our strategy and Maths: y = b + (x-a)*alpha
        if(y>=0 && y<b) countt++;
    }

    cout << countt << endl;

    return 0;
}
