#include<iostream>
using namespace std;

const int Max_N=5010;

bool have_found;
int n,k,m=1;
int table [Max_N][Max_N];

int sum_first [Max_N][Max_N];

void create_sum_first_table(){
sum_first [0][0]=table [0][0];
for(int counter=1;counter<n;counter++){
    sum_first [counter][0]=sum_first[counter-1][0]+table[counter][0];
}
for(int counter=1;counter<n;counter++){
    sum_first [0][counter]=sum_first[0][counter-1]+table[0][counter];
}
for(int counter=1;counter<n;counter++){
    for(int second_counter=1;second_counter<n;second_counter++){
        sum_first[second_counter][counter] = sum_first [second_counter-1][counter]+sum_first[second_counter][counter-1]+table[second_counter][counter]-sum_first[second_counter-1][counter-1];
    }
}
return;
}

int calculate_sum(int x,int y,int m){
if(x==0 and y==0){
    return sum_first[m-1][m-1];
}
if(x==0){
    return sum_first[m-1][y+m-1]-sum_first[m-1][y-1];
}
if(y==0){
    return sum_first[x+m-1][m-1]-sum_first[x-1][m-1];
}
return ((sum_first[x+m-1][y+m-1]+sum_first[x-1][y-1])-(sum_first[x+m-1][y-1]+sum_first[x-1][y+m-1]));
}


int main(){
//ios_base::sync_with_stdio(false);
cin>>n>>k;
for(int counter=0;counter<n;counter++){
    for(int second_counter=0;second_counter<n;second_counter++){
        cin>>table[second_counter][counter];
    }
}
create_sum_first_table();
for(m=1;m<=n;m++){
    have_found=true;
    for(int y=0;y<n-m+1;y++){
        for(int x=0;x<n-m+1;x++){
            if(calculate_sum(x,y,m)<k){
                have_found=false;
            }
        }
    }
    if(have_found){
        cout<<m;
        return 0;
    }
}
cout<<"-1";
return 0;
}
